      subroutine gettimephaselist (depth,delta,n,takeoffang,t_tt,c_tt,
     1 modelname,length,returnCode,returnStr)
      save
      include 'ttlim.inc'
                    character*128 returnStr
                    integer    returnCode
                    integer  length
                    character*256 modelname
      parameter (max=90)
        real depth,delta,t_tt(87)
         integer    i_exit_code
         integer n
c=======================================================
           real*4 vpsource,emer_ang
           character*80 err_txt
c=======================================================
      logical log,prnt(3)
      character*8 phlst(10), phcd
      character*9 c_tt(87)

      common/pcdc/phcd(jbrn)
      character*20 modnam
      common /mst_tt/tt(max),dtdd(max),dtdh(max),dddp(max)
     1       ,mn(max),ts(max)
      dimension usrc(2)
      data in/1/,modnam/'iasp91'/,phlst(1)/'query'/,prnt(3)/.true./

c
      prnt(1) = .false.
      prnt(2) = .false.
      call tabin(in,modelname,length)
      call brnset(1,phlst,prnt)
           
c                                    choose source depth
                                       zs = depth
      if(zs.lt.0.) go to 13
      call depset(zs,usrc)
c                                   delta = 40.
      if(delta.lt.0.) go to 13
c      write(6,*)
c     %'  delta    # code       time(s)    (min s)    dT/dD',
c     %'     dT/dh      d2T/dD2'
      call trtm(delta,max,n,tt,dtdd,dtdh,dddp,phcd)
      if(n.le.0) go to 2
      do 4 i=1,n
        mn(i)=int(tt(i)/60.)
        ts(i)=amod(tt(i),60.)
 4    continue
c    ccccccccccccccccccccccccc
        do 9999 i=1,n
                 t_tt(i) = tt(i)
                 c_tt(i)  = phcd(i)
                 ind=index(phcd(i),' ')
                 c_tt(i)(ind:ind)  = CHAR(0)
9999     continue 
c         print *, 'ttimes  depth   delta ',depth,delta
c      write(*,100)delta,(i,phcd(i),tt(i),mn(i),ts(i),dtdd(i),dtdh(i),
c     1 dddp(i),i=1,n)
c 100  format(/1x,f6.2,i5,2x,a,f9.2,i4,f7.2,f11.4,1p2e11.2/
c     1 (7x,i5,2x,a,0pf9.2,i4,f7.2,f11.4,1p2e11.2))
c    ccccccccccccccccccccccccc

c///==================================================================================================
	call vploc(depth,vpsource,modelname,length)
	ierr=0
	call emerge(vpsource,depth,dtdd(1),dtdh(1),emer_ang,ierr,err_txt)
	if(ierr.ne.0) then
 	returnCode = -2
        returnStr = err_txt(1:80)
	takeoffang=999.
        call retrns(in)
			RETURN
			end if
	takeoffang=90.-emer_ang

c///====================================================================================================
      returnCode = 0
      returnStr = 'ok@'
      call retrns(in)
       return

 2    returnCode = -1
      returnStr = 'No arrival time@'
      call retrns(in)
      return
 

c                                    end delta loop
 13   call retrns(in)
      returnCode = -1
      returnStr = 'Depth or Delta is less zero@'
      return


      end

c///====================================================================================================
c///====================================================================================================
c///===================just take of angles =============================================================
      subroutine takeofvp(depth,delta,n,takeoffang,vpsource,
     1 modelname,length,returnCode,returnStr)
      save
      include 'ttlim.inc'
                    character*128 returnStr
                    integer    returnCode
                    integer  length
                    character*256 modelname
      parameter (max=90)
c        real depth,delta
         integer    i_exit_code
         integer n 
c=======================================================
           real*4 emer_ang,depth,delta,takeoffang,vpsource
           character*80 err_txt
c=======================================================
      logical log,prnt(3)
      character*8 phlst(10), phcd

      common/pcdc/phcd(jbrn)
      character*20 modnam
      common /mst_tt/tt(max),dtdd(max),dtdh(max),dddp(max)
     1       ,mn(max),ts(max)
      dimension usrc(2)
      data in/1/,modnam/'iasp91'/,phlst(1)/'query'/,prnt(3)/.true./
c
      prnt(1) = .false.
      prnt(2) = .false.
      call tabin(in,modelname,length)
      call brnset(1,phlst,prnt)
        

           
c                                    choose source depth
                                       zs = depth
      if(zs.lt.0.) go to 13
      call depset(zs,usrc)
c                                   delta = 40.
      if(delta.lt.0.) go to 13
c      write(6,*)
c     %'  delta    # code       time(s)    (min s)    dT/dD',
c     %'     dT/dh      d2T/dD2'
      call trtm(delta,max,n,tt,dtdd,dtdh,dddp,phcd)
      if(n.le.0) go to 2
      do 4 i=1,n
        mn(i)=int(tt(i)/60.)
        ts(i)=amod(tt(i),60.)
 4    continue

c///==================================================================================================
	ierr=0
	call emerge(vpsource,depth,dtdd(1),dtdh(1),emer_ang,ierr,err_txt)
	if(ierr.ne.0) then
 	returnCode = -2
        returnStr = err_txt(1:80)
	takeoffang=999.
        call retrns(in)
			RETURN
			end if
	takeoffang=90.-emer_ang
c        print*,'takeoffang ',takeoffang
c///====================================================================================================
      returnCode = 0
      returnStr = 'ok@'
      call retrns(in)
       return

 2    returnCode = -1
      returnStr = 'No arrival time@'
      call retrns(in)
      return
 

c                                    end delta loop
 13   call retrns(in)
      returnCode = -1
      returnStr = 'Depth or Delta is less zero@'
      return


      end
