#include "FmtEcmdw.h"
#include "math.h"
// #include <algorithm>
void sort(int ,char ** ) ;
extern "C" { 
extern   void       azidmod_ (float *,float *,float *,float *,float *,float *,float *,float *,float *);
}

       enum {
	m_FirstCmd      = 5, // Dummy Command
	mdFrm0          = 10, 
        MpIcon          = 80,

	lblInfoStat     = 120,
	m_ModalDialog   = 210,	

        IdStaList       = 300,
        IdEventList     = 310,
        IdSelStaList    = 320,
	IdGroupList     = 340,

	IdGroupCombo    = 410,

	btnMap          = 510,
	btnAdd	        = 520,
        btnMark       = 530,
	btnChangeBase	        = 540,
	btnUnMark	= 550,
	btnAddProject   = 560,
	btnMok          = 670,
	btnCreateGroup  = 680,


	lblTestStat     = 1000,	// Status Bar test
	lblCurTime      = 1010,	// Date/Time field
        lblBlank        = 1020,   
	lblEventList    = 1030,
	lblStaList      = 1040,
	lblSelStaList   = 1050,
	lblGroupStaList   = 1060,


	lboxNuEventList     = 2010,
	lboxNuStaList       = 2020,
	lboxNuSelStaList    = 2030,
	lboxNuGroupStaList  = 2040,
	blkLast		// Last item
      };
//@V@:EndIDs
extern  CommandObject ToolBar2[]; 
	char mainStation[64];
void 
FmtOriginCmdWindow::ActionOnGroupList(){
	int ItVal   = GetValue(IdGroupList);
        if (ItVal == -1 ) { 
			SetValue(IdGroupList,-1,Value);
			return;}
	char searchInGrList[64];
	strcpy(searchInGrList,GroupStaList[ItVal]);

        if( ChangeStationGroup (searchInGrList) ) {
	fprintf(stderr,"Error: no Station Group for '%s'\n",searchInGrList);
	return;
 	};
int i;

	 ToolBar2[8].itemList = SelStaList;
	 SetValue(IdSelStaList,-1,ChangeListPtr);

	 ToolBar2[16].itemList = GroupStaList;  
	 SetValue(IdGroupList,-1,ChangeListPtr);	

	for (i = 0; i < N_StaList; i++)
	if (!strncmp(StaList [i],searchInGrList, strlen(searchInGrList)))
	    break;
	SetValue(IdStaList,i,Value);

	for (i = 0; i < N_SelStaList; i++)
	if (!strncmp(SelStaList [i],searchInGrList, strlen(searchInGrList)))
	    break;
	SetValue(IdSelStaList,i,Value);

	for (i = 0; i < N_GroupStaList; i++)
	if (!strncmp(GroupStaList [i],mainStation, strlen(mainStation)))
	    break;
	SetValue(IdGroupList,i,Value);

}
bool   
FmtOriginCmdWindow::ChangeStationGroup (char *searchInGrList)
{
	bool findGroup = false; int i,j;

	list<char *> lst ;
	list<char *>::iterator itrLst;

        for(itsItrStationGroupList=itsStationGroupList.begin();
	itsItrStationGroupList!=itsStationGroupList.end(); 

        itsItrStationGroupList++) {

	   lst = (*itsItrStationGroupList)->GetStationList();
           for(itrLst=lst.begin();itrLst!=lst.end();itrLst++)   {
	   if (!strncmp((*itrLst),searchInGrList,strlen(searchInGrList))){
	   strcpy(mainStation,(*itsItrStationGroupList)->GetMainStation());
	   strcpy((*itsItrStationGroupList)->GetMainStation(), searchInGrList);

	   findGroup = true; break;}       
          }
		if (findGroup == true) break;
	}
   		if (findGroup == false) return 1;
/*
	fprintf(stderr,"\nFind: Station Group for '%s'\n",searchInGrList);

	fprintf(stderr,"'$$$ Main '%s'  Num %d\n", (*itsItrStationGroupList)->GetMainStation(),(*itsItrStationGroupList)->GetNumberStation());

	lst = (*itsItrStationGroupList)->GetStationList();
	
	for(itrLst=lst.begin();itrLst!=lst.end();itrLst++) 
	fprintf(stderr,"'%%%%  '%s'\n",(*itrLst)); 
*/

	for (i = 0; i < N_SelStaList; i++)  {
	   if (!strncmp(SelStaList [i],mainStation,strlen(mainStation)))
	   { strcpy(SelStaList [i],searchInGrList); break;}
	}
	if (i == N_SelStaList) return 1;
/*
	for (i = 0; i < N_SelStaList; i++) 
	fprintf(stderr,"### '%s'\n",SelStaList [i]); 
*/
	 sort(N_SelStaList,SelStaList);

        int   N_NewList = lst.size();
        char  **NNewList = new char *[N_NewList];
	  int	itrInt = 0;

           for(itrLst=lst.begin();itrLst!=lst.end();itrLst++)   {
           NNewList[itrInt] = new char[64];
           strcpy(NNewList[itrInt],(*itrLst));
		itrInt++;
          }
  	        Set_GroupList(NNewList, N_NewList);
		Delete2DCharArray(N_NewList,NNewList);

	for (i = 0; i < N_GroupStaList; i++)  {
	if (!strncmp(GroupStaList [i],searchInGrList, strlen(searchInGrList)))
	   { strcpy(GroupStaList [i],mainStation); break;}
	}

        sort(N_GroupStaList,GroupStaList);




	   lst = (*itsItrStationGroupList)->GetStationList();
	   (*itsItrStationGroupList)->GetStationList().clear();
	

//	for(itrLst=lst.begin();itrLst!=lst.end();itrLst++) 
//	fprintf(stderr,"'###  '%s'\n",(*itrLst)); 

	  for (i = 0; i < N_GroupStaList; i++)          
	  for (j = i; j < N_StaList; j++)
          if (!strncmp(StaList [j],GroupStaList [i], strlen(GroupStaList [i])) ){ 

//fprintf(stderr,"StaList '%s' GroupStaList '%s'\n",StaList [j],GroupStaList [i]);


(*itsItrStationGroupList)->GetStationList().push_back(StaList [j]); 

}



//	fprintf(stderr,"\nFind: Station Group for '%s'\n",searchInGrList);

/*
	fprintf(stderr,"ChangeGroup Main '%s'  Num %d\n", (*itsItrStationGroupList)->GetMainStation(),(*itsItrStationGroupList)->GetNumberStation());
	lst = (*itsItrStationGroupList)->GetStationList();	
	for(itrLst=lst.begin();itrLst!=lst.end();itrLst++) 
	fprintf(stderr,"ChangeGroup  '%s'\n",(*itrLst)); 

*/	
         return 0;
}
void 
FmtOriginCmdWindow::CreateGroups(float angleSelect ){

if (!itsStationGroupList.empty() ) {
           for(itsItrStationGroupList=itsStationGroupList.begin();
	   itsItrStationGroupList!=itsStationGroupList.end(); 
           itsItrStationGroupList++) delete *itsItrStationGroupList;
	   itsStationGroupList.clear();
}
int i;
bool indBool;
float lat,lon,latBase,lonBase,latEv,lonEv;
float del,dis,azfr,azto,err_slat,AzTostBase; 
float Rad = (float)((float)4.*(float)atan(1.)/(float)180.);
float Deg = (float)180./( (float)4.*(float)atan(1.) ); 
char stationName[24],stationBaseName[24];

   SET_SEI *ps = pCDbeSeis->ps;
   N_EventList = ps->n_or;
   ORIG **WRORIG = ps->ori;
	 ORIG *wr;
         wr = WRORIG[NMainShock];
/*
wr->month,
wr->day,
wr->year - 1900,
wr->doy,
wr->hour,
wr->minute ,
wr->second,
wr->latitude ,
wr->longitude,
wr->dep ,
wr->mb,
wr->ms
*/

latEv = wr->latitude * Rad;
lonEv = wr->longitude * Rad;


	list<char *> wrkStationList;  
	list<char *>::iterator wrkItrStaListBase; 
	list<char *>::iterator wrkItrStationList; 

	for (i = 0; i < N_StaList; i++) 
		wrkStationList.push_back(StaList[i]);
	
/*
           for(wrkItrStationList=wrkStationList.begin(); 		
	   wrkItrStationList!=wrkStationList.end(); 
           wrkItrStationList++)
          fprintf(stderr,"%s\n",(*wrkItrStationList));
*/



while(!wrkStationList.empty()){



wrkItrStaListBase=wrkStationList.begin();
	char *baseStr = new char[strlen((*wrkItrStaListBase))+1];
        strcpy(baseStr,(*wrkItrStaListBase));
			StationGroup *ptrStationGroup = 
			new StationGroup(baseStr);
                        itsStationGroupList.push_back(ptrStationGroup);
        itsItrStationGroupList = itsStationGroupList.end();
	itsItrStationGroupList--;

	 sscanf((*wrkItrStaListBase),"%s%f%f",
         stationBaseName,&latBase,&lonBase);

latBase    *= Rad;
lonBase    *= Rad;

		        wrkStationList.remove((*wrkItrStaListBase));
///////////////////////////////////////////////////////////////
azidmod_(&latBase,&lonBase,&latEv,&lonEv,&del,&dis,&azfr,&azto,&err_slat);                                
                     if ( err_slat > 0.001) {
             fprintf(stderr,"Info: FmtGrStation (a):  distance calculation: \n(%s) <-> Main Shock\nlatitude is reduced by  % 6.2f degree.\n",
stationBaseName,err_slat);

             }

AzTostBase   =   azto*Deg;

///////////////////////////////////////////////////////////////

           for(wrkItrStationList = wrkStationList.begin();
	   wrkItrStationList!=wrkStationList.end(); 
           wrkItrStationList++)   {
	   sscanf((*wrkItrStationList),"%s%f%f",
           stationName,&lat,&lon);
lat    *= Rad;
lon    *= Rad;

azidmod_(&lat,&lon,&latEv,&lonEv,&del,&dis,&azfr,&azto,&err_slat);                                
                     if ( err_slat > 0.001) {
             fprintf(stderr,"Info: FmtGrStation (b): distance calculation: \n(%s) <-> Main Shock \nlatitude is reduced by  % 6.2f degree.\n",
stationName,err_slat);

             }



azto  *= Deg;



		if (  fabs(azto - AzTostBase) <= angleSelect )
		 { 
/*
fprintf(stderr," del '% 8.3f'  lab % 8.3f lac = % 8.3f lob % 8.3f loc = % 8.3f  \n",
del,latBase*Deg,lat*Deg,lonBase*Deg,lon*Deg);
*/
 (*itsItrStationGroupList)->GetStationList().push_back((*wrkItrStationList));
			(*itsItrStationGroupList)->GetNumberStation() += 1;

		        wrkStationList.remove((*wrkItrStationList));
		        wrkItrStationList--;

			}	

	}// wrkItrStationList

}//!wrkStationList.empty()


// PRINT STATION GROOP:
fprintf(stderr,"\nStation Groups % 3d Angle % 3.0f degrees\n\n",
itsStationGroupList.size(),angleSelect);


           int numGroup = 1; 
           for(itsItrStationGroupList=itsStationGroupList.begin(); 		
	   itsItrStationGroupList!=itsStationGroupList.end(); 
           itsItrStationGroupList++)   {
	    fprintf(stderr,"% 3d :> <%s> - Base; % 3d - stations\n",numGroup++,
	    (*itsItrStationGroupList)->GetMainStation(),  
	    (*itsItrStationGroupList)->GetNumberStation());
	    list<char *> lst = (*itsItrStationGroupList)->GetStationList();
	    list<char *>::iterator itrLst;

           int numStationInGroup = 1;
	   for(itrLst=lst.begin(); itrLst!=lst.end(); itrLst++)
	   fprintf(stderr,"   % 3d '%s'\n",numStationInGroup++,(*itrLst));



	}

          int N_NewList = itsStationGroupList.size();
          char **NNewList = new char *[N_NewList];
		int itrInt = 0;
           for(itsItrStationGroupList=itsStationGroupList.begin(); 		
	   itsItrStationGroupList!=itsStationGroupList.end(); 
           itsItrStationGroupList++)   {
          NNewList[itrInt] = new char[64];
          strcpy(NNewList[itrInt],(*itsItrStationGroupList)->GetMainStation());
		itrInt++;
          }

	        Set_SelStaList(NNewList, N_NewList);
		Delete2DCharArray(N_NewList,NNewList);

// Fill Station Group List for first Base Station
	    itsItrStationGroupList=itsStationGroupList.begin();
	    list<char *> lst = (*itsItrStationGroupList)->GetStationList();
	    list<char *>::iterator itrLst;
	    if (lst.empty() ) return;
           itsItrCurrentStationGroupList  =  itsItrStationGroupList;

          N_NewList = lst.size();
          NNewList = new char *[N_NewList];
		itrInt = 0;

           for(itrLst=lst.begin();itrLst!=lst.end();itrLst++)   {
           NNewList[itrInt] = new char[64];
          strcpy(NNewList[itrInt],(*itrLst));
		itrInt++;
          }

/*
for( i = 0; i < N_NewList; i++)
fprintf(stderr,"$$$$$   '%s'\n",NNewList[i]);
*/

	        Set_GroupList(NNewList, N_NewList);
		Delete2DCharArray(N_NewList,NNewList);


return;

}
void 
FmtOriginCmdWindow::SetGroupListValueZero() {

	 ToolBar2[16].itemList = GroupStaList;  
	 SetValue(IdGroupList,-1,ChangeListPtr);
 itsItrStationGroupList=itsStationGroupList.begin();
	    list<char *> lst = (*itsItrStationGroupList)->GetStationList();
	    list<char *>::iterator itrLst;
	    if (lst.empty() ) return;
           itsItrCurrentStationGroupList  =  itsItrStationGroupList;

          int N_NewList = lst.size();
          char **NNewList = new char *[N_NewList];
		int itrInt = 0;

           for(itrLst=lst.begin();itrLst!=lst.end();itrLst++)   {
           NNewList[itrInt] = new char[64];
          strcpy(NNewList[itrInt],(*itrLst));
		itrInt++;
          }

	        Set_GroupList(NNewList, N_NewList);
		Delete2DCharArray(N_NewList,NNewList);


	
return;
}
#include <time.h>

void 
FmtOriginCmdWindow::SaveGroupList(){
FILE *out;
char *OutName = new char [strlen(CSpPrSaveName)+24];
strcpy(OutName,CSpPrSaveName);strcat(OutName,".list");
char *OutNameCopy = new char [strlen(OutName)+24];
strcpy(OutNameCopy,OutName);strcat(OutNameCopy,"%");
//char *str = new char [strlen(CSpPrSaveName)+strlen(OutName) + 24 ];
 if (!(out = fopen(OutName, "r")) == 0)
	   {
		    fclose(out);
char *str = new char [strlen(CSpPrSaveName)+strlen(OutName) + 24 ];
strcpy (str,"mv ");
strcat(str,OutName); strcat(str," ");
strcat(str,OutNameCopy);
system(str);
delete str;
	  }



 if ((out = fopen(OutName, "w")) == 0)
	   {
	   	    (void) fprintf(stderr,
		    "Fatal Error: Output file '%s' is not available for writing.\n",
			   OutName);
		    delete OutName;delete OutNameCopy;
	    	    return;
	  }

			struct tm timet;
			struct tm *ttm;
                	long itime;
		itime = time(NULL);
		ttm = &timet;
		ttm = localtime(&itime);

fprintf(out,"                     Date:    %s\n",strchr(asctime(ttm),' '));
int i; char str[64];
fprintf(out,"\nList of Selected Stations:\n\n");
	for (i = 0; i < N_SelStaList; i++)  {
	if (SelStaList[i][strlen(SelStaList[i]) - 1] != markerChar)
	fprintf(out,"%s\n", SelStaList[i]);
	}

fprintf(out,"\nList of rest of Stations:\n\n");
	for (i = 0; i < N_SelStaList; i++)  {
	if (SelStaList[i][strlen(SelStaList[i]) - 1] == markerChar){
        strcpy(str,SelStaList[i]); str[strlen(SelStaList[i]) - 1] = '\0';
	fprintf(out,"%s\n", str);
	}
	}


fprintf(out,"\nStation Groups % 3d Angle % 3.0f degrees\n\n",
itsStationGroupList.size(),angleSelect);

           int numGroup = 1; 
           for(itsItrStationGroupList=itsStationGroupList.begin(); 
	   itsItrStationGroupList!=itsStationGroupList.end(); 
           itsItrStationGroupList++)   {

	for (i = 0; i < N_SelStaList; i++)  {
        if (!strncmp(SelStaList [i], (*itsItrStationGroupList)->GetMainStation(),strlen((*itsItrStationGroupList)->GetMainStation())))  break;
	}

        if (SelStaList[i][strlen(SelStaList[i]) - 1] == markerChar)
	    fprintf(out,"x % 3d :> <%s> - Base; % 3d - stations\n", 
	     numGroup++,
	    (*itsItrStationGroupList)->GetMainStation(),  
	    (*itsItrStationGroupList)->GetNumberStation());

else
	    fprintf(out,"  % 3d :> <%s> - Base; % 3d - stations\n", 
	     numGroup++,
	    (*itsItrStationGroupList)->GetMainStation(),  
	    (*itsItrStationGroupList)->GetNumberStation());

	    list<char *> lst = (*itsItrStationGroupList)->GetStationList();
	    list<char *>::iterator itrLst;

           int numStationInGroup = 1;
	   for(itrLst=lst.begin(); itrLst!=lst.end(); itrLst++)
	   fprintf(out,"     % 3d '%s'\n",numStationInGroup++,(*itrLst));



	}


fprintf(out,"\n");
fprintf(out,"List of Project Working Files\n- <%s>\n", 
CSpPrSaveName);
fprintf(out,"Working directory\n- <%s>\n",
m_WorkDir);
fprintf(out,"Db Datascope Wfdisc Name\n- <%s>\n",
pCDbeSeis->Get_DbeName());
fprintf(out,"Db Datascope Root Name for Response\n- <%s>\n", 
pCDbeSeis->Get_DbeOriginName());
fprintf(out,"Db Datascope Origin Name for Event\n- <%s>\n",
pCDbeSeis->Get_DbeOriginName());
fprintf(out,"\n\n");

fclose(out);
delete OutName;
delete OutNameCopy;
return;
}
