#include "SpPrcss.h"

#define PI 3.14159
#define _MAX_FILE_NAME 200
int  Fill_Db2Sei_1(SET_SEI *,DBLink *,DBLink *,DBLink *,char *);  
int  Fill_Db2Sei_2(SET_SEI *,char *);

extern   void       azidmod_ (float *,float *,float *,float *,float *,float *,float *,float *,float *);
//void __eprintf ();

        int mday2doy();
	int etoh();
int  Get_Seiemograms_From_db(SET_SEI *ps,char *DbName,char *DbRootName,char *DbOriginName,char *OutErr){
char  str[_MAX_FILE_NAME],WdiscDb[_MAX_FILE_NAME],
RootDb[_MAX_FILE_NAME],OriginDb[_MAX_FILE_NAME];
int   ntuples_in,ntuples_or,i;
char *ptr;
  DBLink *Ldbin;
  DBLink *LdRootbin;
  DBLink *LdOriginbin;
      
  
  strcpy(OutErr,DbName);
  if ( !( ptr = strrchr(OutErr,'.') ) ) {
    sprintf( OutErr,"Error:> %s isn't RootDBase Name \n", strrchr(DbName,'/')+1);
    return 1;                           }
  *strrchr(OutErr,'.') = '\0';
  fprintf(stderr,"WFDisc :> '%s'\n",OutErr);   

   strcpy(str,strrchr(DbName,'/')+1);
   *strrchr(str,'.') = '\0';
   strcpy(WdiscDb,str);
   Ldbin  =  db30_create(OutErr);
 
            if( DBL_exist_db(Ldbin) == 0 ) {
               
              sprintf( OutErr,"Error:> Name '%s' isn't RootDBase Name \n", str );
              return 1;
           }
      if( DBL_exist_rel(Ldbin,"wfdisc") == 0 ) {
              sprintf( OutErr,"Error:> DBase '%s' doesn't contain WfDisc relation\n",str);
              return 2;
           }
  strcpy(OutErr,DbRootName);
  if ( !( ptr = strrchr(OutErr,'.') ) ) {
    sprintf( OutErr,"Error:> %s isn't RootDBase Name\n" ,strrchr(DbRootName,'/')+1);
    return 1;                           }
  *strrchr(OutErr,'.') = '\0';
  fprintf(stderr,"DbRoot :> '%s'\n",OutErr);   

   strcpy(str,strrchr(DbRootName,'/')+1);
   *strrchr(str,'.') = '\0';
strcpy(RootDb,str);
   LdRootbin  =  db30_create(OutErr);


     if( DBL_exist_rel(LdRootbin,"sensor") == 0 ) {
              
              sprintf( OutErr,"Error:> DBase '%s' doesn't contain DBSensor relation\n",str);
              return 3;
           }
     if( DBL_exist_rel(LdRootbin,"instrument") == 0 ) {
              sprintf( OutErr,"Error:> DBase '%s' doesn't contain Instrument relation\n",str);
              return 4;
           }
     if( DBL_exist_rel(LdRootbin,"site") == 0 ) {
               sprintf( OutErr,"Error:> DBase '%s' doesn't contain Site relation\n",str);
               return 5;
           }

  strcpy(OutErr,DbOriginName);
  if ( !( ptr = strrchr(OutErr,'.') ) ) {
    sprintf( OutErr,"Error:> %s isn't RootDBase Name\n" ,strrchr(DbOriginName,'/')+1);
    return 1;                           }
  *strrchr(OutErr,'.') = '\0';

   strcpy(str,strrchr(DbOriginName,'/')+1);
   *strrchr(str,'.') = '\0';
strcpy(OriginDb,str);
   LdOriginbin  =  db30_create(OutErr);

     if( DBL_exist_rel(LdOriginbin,"origin") == 0 ) {
               sprintf( OutErr,"Error:> DBase '%s' doesn't contain Origin relation\n",str);
               return 6;
           }

       
       ps->n     =  ntuples_in = DBL_get_ntuples(Ldbin,"wfdisc");  
       ps->n_or  =  ntuples_or = DBL_get_ntuples(LdOriginbin,"origin");
    fprintf(stderr,"DbOrigin :> '%s' - %d Records\n",OutErr,ps->n_or);   
 
 if  ( !(ps->sei = malloc (sizeof(SEI *)* ntuples_in) )){
          fprintf(stderr,"Syst:SpPrcss: Not free memory for              ps->sei\n");
            sprintf( OutErr,"Error:> Syst:SpPrcss: Not free memory for              ps->sei\n");
     
      return 7;
     }
   for (i = 0; i< ntuples_in; i++ ) {
      if  ( !(ps->sei[i] = malloc (sizeof(SEI )) )){
          fprintf(stderr,"Syst: SpPrcss: Not free memory for ps->sei[%d]\n",i);     
 sprintf( OutErr,"Error:> Syst:SpPrcss: Not free memory for              ps->sei[%d]\n",i);

return 8;
     }  
ps->sei[i]->s = 0;
}
//////////////////////////
if  ( !(ps->ori = malloc (sizeof(ORIG *)* ntuples_or) )){
          fprintf(stderr,"Syst:SpPrcss: Not free memory for              ps->ori\n");
            sprintf( OutErr,"Error:> Syst:SpPrcss: Not free memory for              ps->ori\n");
     
      return 9;
     }
   for (i = 0; i< ntuples_or; i++ ) {
      if  ( !(ps->ori[i] = malloc (sizeof(ORIG )) )){
          fprintf(stderr,"Syst: SpPrcss: Not free memory for ps->ori[%d]\n",i);     
 sprintf( OutErr,"Error:> Syst:SpPrcss: Not free memory for              ps->ori[%d]\n",i);

return 10;
     }  

}
 if (Fill_Db2Sei_1(ps,Ldbin,LdRootbin,LdOriginbin,OutErr) ){
return 101;

}
/*
 if (Fill_Db2Sei_2(ps,OutErr) ) {
return 102;

}
*/

sprintf( OutErr,"Wfdisc Db: '%s' %d records\n Root Db for Instrument: '%s'\n Origin Db: '%s'\n",WdiscDb,ntuples_in,RootDb,OriginDb);
 DBL_free(Ldbin);
 DBL_free(LdRootbin);
 DBL_free(LdOriginbin); 
     
return 0;
}

 int 
 Fill_Db2Sei_1(SET_SEI *ps,DBLink *Ldbin,DBLink *LdRootbin,DBLink *LdOriginbin,char *OutErr){

         char  str[128];
         SEI *wf; 
	 ORIG *wr;
         int relid; 
         struct date_time human_time;       /* Epoch time for humans            */
         char chan_cor[9],LRchan[9];
         long curdate;
         int yday,doy;
         int i;
         double etime;
         int eyear,eday,emonth,ehour,emin;
         float esec,elat,elon,edepth,mb,ms,ml;

/*  Recive Event Info    */


relid = (int)DBL_get_relid(LdOriginbin,"origin");
for (i = 0; i< ps->n_or; i++ ){
      
       wr = ps->ori[i];
if (!DBL_get_attrs(LdOriginbin,relid,i,  
                                          
                                       "time"      ,&etime,     
                                       "lat"       ,&elat,
                                       "lon"       ,&elon,
                                       "depth"     ,&edepth,
				"mb", &mb,
				"ms", &ms,
				"ml", &ml,

                                     NULL)  ) {             
        fprintf(stderr,
        "Error: SpPrcss: Attribute-valueField reading in origin relation\n");
        sprintf( OutErr,"Error: Origin relation. Attribute-valueField reading.\n");
              return 1;

           }
  	human_time.epoch = etime;

	etoh(&human_time);

 
          eyear     = human_time.year;
          eday      = human_time.day;
          emonth    = human_time.month;
          ehour     = human_time.hour;
          emin      = human_time.minute;
          esec      = human_time.second;

/*  Recive Event Info    */
if (mb < 0) mb = 0.;
if (ms < 0) ms = 0.;
if (ml < 0) ml = 0.;
		doy = mday2doy (eyear, emonth, eday); 
wr->epoph = etime;
wr->year = eyear;
wr->month = emonth;
wr->day = eday;
wr->hour = ehour;
wr->minute = emin;
wr->second = esec;
wr->latitude = elat;
wr->longitude = elon;
wr->dep = edepth;
wr->mb = mb;
wr->ms = ms;
wr->ml = ml;
wr->doy = doy;
/*
        fprintf(stderr,"Event:>  year = %d month = %d day = %d\nEvent:>  hour = %d minute = %d second = %g, epoph = %g\n",
        wr->year,wr->month,wr->day,
        wr->hour,wr->minute,wr->second,wr->epoph);
        fprintf(stderr,"Event:>  lat = %g lon = %g depth = %g\n",wr->latitude,wr->longitude,wr->dep);
*/

 } // loop origin 


   relid = (int)DBL_get_relid(Ldbin,"wfdisc");
   for (i = 0; i< N_SEI; i++ ){
             wf = ps->sei[i];
             if (!DBL_get_attrs(Ldbin,relid,i,  
                                       "sta"      ,wf->sta,       
                                       "chan"      ,wf->chan,    
                                       "chanid"    ,&wf->chanid ,   
                                       "time"      ,&wf->time,     
                                       "endtime"   ,&wf->endtime,   
                                       "jdate"     ,&wf->jdate,    
                                       "nsamp"     ,&wf->nsamp,    
                                       "calib"     ,&wf->calib,     
                                       "calper"    ,&wf->calper,    
                                       "samprate"  ,&wf->samprate,   
                                        "segtype"  ,&wf->segtype,   
                                        "dir"      ,wf->dir,       
                                        "dfile"    ,wf->dfile,     
                                        "wfid"     ,&wf->wfid,      
                                        "instype"  ,wf->instype,  
                                        "datatype" ,wf->datatype,  
                                        "clip"     ,wf->clip,     
                                        "foff"     ,&wf->foff, 
                                        "commid"   ,&wf->commid,    
                                        "lddate"   ,&wf->lddate,    
                                     NULL)  ) {             
        fprintf(stderr,
        "Error: SpPrcss: Attribute-valueField reading <%s>.wfdisc \n");
 sprintf( OutErr,"Error: Wfdisc relation. Attribute-valueField reading.\n");
              return 2;

           }
          wf->year   = eyear;
          wf->month  = emonth;
          wf->day    = eday;
          wf->hour   = ehour ;
          wf->minute = emin  ;
          wf->sec    = esec  ;
          wf->elat   = elat;
          wf->elong  = elon;
          wf->depth = edepth;

    strcpy(chan_cor,wf->chan);
strcpy(wf->inichan,wf->chan);  
    if (strchr(chan_cor,'b') != NULL) {

strcpy(chan_cor,"B"); strcat(chan_cor,strchr(wf->chan,'b') + 1);
strcpy(wf->chan,chan_cor);
}
    strcpy(wf->LRchan,strrchr(wf->dfile,'.') + 1 );
 
//fprintf(stderr,"** Rec %s:%s : inichan = %s LRchan = %s\n",
//  wf->sta, wf->chan,wf->inichan,wf->LRchan );


          strcpy(wf->st_name,wf->sta);
          strcpy(wf->instr,wf->chan);
          wf->nsampl = wf->nsamp;
                      if( wf->samprate <= 0)
                        {
                       fprintf(stderr,"Error: SpPrcss: samprate for '%s:%s'is wrong. \n",
                       wf->sta,wf->chan);
 sprintf( OutErr,"Error: Samprate for '%s:%s'is wrong. \n",
                       wf->sta,wf->chan);

                       return 3;
                        }

        wf->dt = 1.0/wf->samprate;
        wf->comp[0] = wf->chan[strlen(wf->chan)-1];
        wf->comp[1] = '\0';
        strcpy(wf->header,"From DB DATASCOPE 1993-1996. University of Colorado. "); 
        wf->t0 = wf->time - etime;
      
  	human_time.epoch = wf->time;
	etoh(&human_time);
        yday = mday2doy(human_time.year,human_time.month,human_time.day);  

    curdate = human_time.year * 1000 + yday;

/*  sensor site instrument */
  do {
  int l,reltuple;
     int sensor_relid;
     int instrument_relid;
     int site_relid;
     int sensor_ntuples;
     int site_ntuples;
     int instrument_ntuples;
     float ncalib,ncalper;
     char sta[7]; char chan[9]; 
     double time; double endtime;
     long  ondate,offdate;
     float lat,lon,elev;
     long sensor_inid;
     long instrument_inid; 
     long site_inid; 
     char dir[_MAX_FILE_NAME]; char dfile[_MAX_FILE_NAME];
     int bool = 0;
     char response_file_name[_MAX_FILE_NAME];
     char rsptype[7];


        sensor_relid       = (int) DBL_get_relid(LdRootbin,"sensor");
        instrument_relid   = (int) DBL_get_relid(LdRootbin,"instrument");
        site_relid         =  (int)DBL_get_relid(LdRootbin,"site");       
        sensor_ntuples     =  DBL_get_ntuples(LdRootbin,"sensor");       
        instrument_ntuples =  DBL_get_ntuples(LdRootbin,"instrument");  
        site_ntuples       =  DBL_get_ntuples(LdRootbin,"site"); 





   l = 0;
  

  do  {
   
    
 bool = 0;
     DBL_get_attrs(LdRootbin,sensor_relid,l,
                        "sta"       ,sta,       
                        "chan"      ,chan,    
                        "inid"      ,&sensor_inid ,   
                        "time"      ,&time,     
                        "endtime"   ,&endtime,   
                        NULL);

          if (endtime == -1 ) endtime = 1262304000.0; /* 2010 Year*/

          if (wf->time < time || wf->time > endtime) bool++;
	  if ( strcmp(wf->sta,sta) !=0) bool++;
	  if ( strcmp(wf->chan, chan) != 0) bool++;
           


           
           l++;
    } while(bool && l < sensor_ntuples); 
if (bool){
 fprintf(stderr,"Error: sta(%s),chan(%s),time(%g) are not found in DbSensor \n",wf->sta,wf->chan,wf->time);
 sprintf( OutErr,"Error: sta(%s),chan(%s),time(%g) are not found in DbSensor \n",wf->sta,wf->chan,wf->time);
return 4; 
}
l = 0;
 do {
        bool = 0;     
        if (!DBL_get_attrs(LdRootbin,instrument_relid,l,
                        "inid"       ,&instrument_inid ,   
                        "ncalib"      ,&ncalib,  
                         "rsptype"    ,rsptype,   
                        "dir"        ,dir,   
                        "dfile"      ,dfile,   
                        NULL)) {
  /* FINISH 3 */              
fprintf(stderr,"Error (Station_Fft): Attribute-value Field reading for Instrument Relation \n");
 sprintf( OutErr,"Error: Attribute-value Field reading for Instrument Relation \n");

              return 5;

           }

    if (sensor_inid != instrument_inid) bool++;
   l++;
  } while (bool &&  l < instrument_ntuples);


if (bool){
 fprintf(stderr,"Error: sta(%s),chan(%s),time(%g) are not found in DbSensor \n",wf->sta,wf->chan,wf->time);
sprintf( OutErr,"Error: sta(%s),chan(%s),time(%g) are not found in DbSensor \n",wf->sta,wf->chan,wf->time);
 return 6;
    }
strcpy(wf->rsptype,rsptype);
strcpy(response_file_name,dir);
strcat(response_file_name,"/");
strcat(response_file_name,dfile);
/*        PRINT  RESPONS FILE NAME   */

/*fprintf(stderr,"Resp:>  (%d) Sta %s Chan %s Name = %s\n", instrument_inid, wf->sta,wf->chan,response_file_name);*/

strcpy(wf->dir_instr,dir);
strcpy(wf->dfile_instr,dfile);


  l = 0;
    do {
 bool = 0;
     DBL_get_attrs(LdRootbin,site_relid,l,
                        "sta"       ,sta,       
                        "lat"       ,&lat,
                        "lon"       ,&lon,
                        "elev"      ,&elev,
                        "ondate"    ,&ondate,     
                        "offdate"   ,&offdate,   
                        NULL);
//ZZZZ DbSite	 
          if ( offdate == -1) offdate  =   1262304000.0;
                                           // >= ??
          if (curdate < ondate  || curdate  > offdate  ) bool++;
	  if ( strcmp(wf->sta,sta) !=0) bool++;

      
           
           l++;
    } while(bool && l <  site_ntuples); 
    if (bool ){ /*l > site_ntuples */
    fprintf(stderr,"Error: sta(%s),time(%g) are not found in DbSite \n",
    wf->sta,wf->time);
sprintf( OutErr,"Error:  sta(%s),time(%g) are not found in DbSite \n",
    wf->sta,wf->time);

    return 7; 
    }
wf->slat       = lat;
wf->slong      = lon;
wf->elevation  = elev;
 /*fprintf(stderr," $$$%s :> slat = %7.3f slong = %8.3f elevation = %4.0f\n",sta,lat,lon,elev);  */
  strcpy(wf->chan,wf->inichan); 
//fprintf(stderr,"** Rec %s:%s   LRchan = %s\n",
//wf->sta, wf->chan,wf->LRchan );

   } while (0);

 
  } /*  End loop i*/

    return 0;
}

int 
 Fill_Db2Sei_2(SET_SEI *ps,char *OutErr){
      
         char  str[128];
         SEI   *wf; 
         char  *ptr;
         char  cptr[8];
         float az;
         char full_name[_MAX_FILE_NAME];
float Radslat,Radslon,Radlat,Radlon; 
float del,dis,azfr,azto,err_slat; 
float Rad = (float)((float)4.*(float)atan(1.)/(float)180.);
float Deg = (float)180./( (float)4.*(float)atan(1.) );
  int i,i1; 
    
 for (i = 0; i< N_SEI; i++ ){
             wf = ps->sei[i];
/*  AZID_MOD           **********************/   
Radslat   = wf->slat*Rad;
Radslon   = wf->slong*Rad;
Radlat    = wf->elat*Rad;
Radlon    = wf->elong*Rad;
      azidmod_(&Radslat,&Radslon,&Radlat,&Radlon,&del,&dis,&azfr,&azto,&err_slat);                                
                     if ( err_slat > 0.001) {
             fprintf(stderr,"Info: Azimuth calculation: Station (%s) latitude is reduced by  % 6.2f degree.\n",wf->st_name,err_slat);

             }    
   /*
   if (i < 5)
   fprintf (stderr,"%s[%c]: Del = %g Dist = %g Azfr = %g Azto = %g \n",
    wf->st_name,wf->comp[0],del* Deg,dis,azfr * Deg,azto * Deg);
*/
      wf->dist  = dis;           
      wf->aztos = azto * Deg;          
      wf->azfrs = azfr * Deg; 
      strcpy(cptr,wf->comp);
      ptr = cptr;
     *ptr = tolower(*ptr); 
    if( !memcmp(ptr ,"e",1) ) {  
         wf->polan   = (float)90.0; 
         wf->az      = (float)90.0;          
        } 
 
    if( !memcmp(ptr ,"n",1) ) { 
         wf->polan   = (float)90.0; 
         wf->az      = (float)0.0; 
        } 
    if( !memcmp(ptr ,"z",1) )  {  
         wf->polan   = (float)0.0; 
         wf->az      = (float)0.0;        
        } 
 
           az =  wf->azfrs - (float)180.0 ;                                      
    if( !memcmp(ptr ,"r",1) )  {  
         wf->polan  =  (float)90.0; 
         wf->az     =  ((az) < 0) ? (az + (float)360.0 ) : (az);        
        } 
 
           az =  wf->azfrs - (float)90.0; 
    if( !memcmp(ptr ,"t",1) )  {  
         wf->polan  =  (float)90.0; 
         wf->az     =  ((az) < 0) ? (az + (float)360.0 ) : (az);        
        } 

/*  AZID_MOD           **********************/  
//*ptr = toupper(*ptr);

/*  RESPONSE           **********************/
                 do {
                      FILE *file ;
                      int add_zer;
                      long iresp;
                      long lh;  
                      long k1;
                      Response *response ; 
                      Response_group *gp ;
                      Paz *paz ;
                      int st;
                      float norm;
                      int   npoles;
                      int   nzeroes;
                      double freq, gain, real, imag, mag, phase ; 
                      char Resp_name[_MAX_FILE_NAME];
float dt;
             float df;
                      if( wf->samprate <= 0)
{
fprintf(stderr,"Error: Samprate for '%s:%s'is wrong. \n",
          wf->sta,wf->chan);
sprintf( OutErr,"Error: Samprate for '%s:%s'is wrong. \n",
          wf->sta,wf->chan);

 return 1;
}

                      else
                      dt = 1.0/wf->samprate;
                      
                      strcpy(Resp_name,wf->dir_instr);
                      strcat(Resp_name,"/");
                      strcat(Resp_name,wf->dfile_instr);
  
                     file = fopen (Resp_name , "r" ) ; 


                      if ( read_response ( file, &response ) != 0 ) 
                         	{
                           	clear_register ( 1 ) ;
               fprintf (stderr,"SpPrcss:> Read response error. \n"); 
                             	}
                      fclose ( file ) ; 


                      st =0;

                      gp = response->groups + st;

                      while(gp->id != PAZ){st++; gp = response->groups + st;} ;
                      paz = (Paz *) gp->private ;
                      norm = paz->normalization ;
                      npoles  = paz->npoles ;
                      nzeroes = paz->nzeros ;

/*  fprintf(stderr,"*Info: rsptype = %c  Resp_name = %s  for '%s:%s'\n",wf->rsptype[0],Resp_name,wf->sta,wf->chan);    */                 

       switch (wf->rsptype[0]) {
         case 'D' :  ;
         break;  
         case 'V' :  paz->nzeros += 1;
         break;
         case 'A' :  paz->nzeros += 2;
         break;
         default:
  fprintf(stderr,"Error: Insrument table does not contain  'response type:(D,V,A)' for '%s:%s' \n",
          wf->sta,wf->chan);
sprintf( OutErr,"Error: Insrument table does not contain  'response type:(D,V,A)' for '%s:%s' \n",
          wf->sta,wf->chan);

       
  return 2;
           
} 

     if (wf->calib > 0.0)
                    wf->amp   = 1.0/( (1.0/ wf->calib)*1.e+09); /* DS */
     else {          
 sprintf( OutErr, " Warning:\n Calibration constant < 0 (!) for '%s:%s'\n Normalisation constant will be 1.0",wf->sta,wf->chan);
 wf->amp   = 1.0;
 }

     wf->amp1   = paz->normalization;   /* AO */

     wf->npol   = paz->npoles; 
      
     wf->nzer   = paz->nzeros ; 

 /*         fprintf(stderr,"%s:%s:> NPOL = %d NZER = %d DS = %e AO = %e \n ",wf->sta,wf->chan,
                      wf->npol,wf->nzer,wf->amp,wf->amp1);
     */
      for (i1=0; i1< paz->npoles; i1++) {
      wf->pol[i1][0]   = paz->poles[i1].real; 
      wf->pol[i1][1]   = paz->poles[i1].imag; 

       }

     for (i1=0; i1< nzeroes; i1++) {
     wf->zer[i1][0]   = paz->zeros[i1].real; 
     wf->zer[i1][1]   = paz->zeros[i1].imag; 

     } 

if  (wf->rsptype[0] == 'V') {
      wf->zer[nzeroes][0]   = (float) 0.0; 
      wf->zer[nzeroes][1]   = (float) 0.0; 
}
if  (wf->rsptype[0] == 'A') {
      wf->zer[nzeroes][0]   = (float) 0.0; 
      wf->zer[nzeroes][1]   = (float) 0.0; 

      wf->zer[nzeroes + 1][0]   = (float) 0.0; 
      wf->zer[nzeroes + 1][1]   = (float) 0.0; 
}

/*    Get_response   

    eval_response ( 0.01 * 2.0 *PI, response, &real, &imag ) ; 
    to_polar ( real, imag, &mag, &phase ) ; 
    gain = 1.0/mag ;       
*/
                free_response ( response ) ; 


                }while (0);   /*  Response Calculating	Get Poles &  Zeros */



/*  RESPONSE           **********************/

/*  Reading Seismograms                      */
/*
           FILE	*in;
if  ( !(wf->s = malloc ( wf->nsampl * sizeof(float )) )){
          fprintf(stderr,"Syst: SpPrcss: Not free memory for ps->sei[%d]->s\n",i);     
 sprintf( OutErr,"Error:> Syst:SpPrcss: Not free memory for              ps->sei[%d]->s\n",i);

return 1;
     }

           strcpy(full_name,wf->dir);
           strcat(full_name,"/");
           strcat(full_name,wf->dfile); 

           if ((in = fopen(full_name, "r")) == NULL)
	   {
	    (void) fprintf(stderr, "\tFatal Error (SpPrcss):  ");
	    (void) fprintf(stderr,
			   "Fatal Error: Input file %s is not available for riding.\n",
			   full_name);
	    sprintf( OutErr, "Fatal Error: Input file %s is not available for riding.\n",
			   full_name);
	    return 5;
	  }
            fread(wf->s,sizeof(float),wf->nsampl,in);
 
 

	  fclose ( in ) ; 
*/

/*  Reading Seismograms                      */     
   } /* End loop i  */
          ps->max_nsampl = 0;
          for( i = 0; i < ps->n; i++) 
          if (ps->max_nsampl < ps->sei[i]->nsampl)
              ps->max_nsampl = ps->sei[i]->nsampl;

return 0;
}
//void __eprintf () {;}
