czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
        subroutine asort1(a,nu1,nu2,k,amax,m,nvar)
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
c-----------------------------------------------------------------------
c       a(i,j) - array of weights; nu1,nu2 - arrays of numbers of 
c       elements "a", ordered with respect to increasing of weigt;
c       k - dimension of "a" with respect to 1-st index (i=1,...,k; 
c       j=1,...,4); amax - maximal weight; m - number of sorted elements
c-----------------------------------------------------------------------
        dimension a(nvar,4)
        integer*4 nu1(1),nu2(1)
        m=0
                        do 6 i=1,k
                        do 6 ii=1,4
                if(a(i,ii).gt.amax)     go to 6
                if(m.eq.0)              go to 41
                        do 4 j=1,m
        n1j=nu1(j)
        n2j=nu2(j)
                if(a(i,ii).ge.a(n1j,n2j)) go to 4
                        do 3 jj=j,m
        n1=m+j-jj
        n2=n1+1
        nu1(n2)=nu1(n1)
        nu2(n2)=nu2(n1)
3                       continue
        nu1(j)=i
        nu2(j)=ii
                                go to 5
4                       continue
41                      continue
        m1=m+1
        nu1(m1)=i
        nu2(m1)=ii
5                       continue
        m=m+1
6                       continue
                                        return
                                        end
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
        subroutine asort2(a,nu1,nu2,k,amax,m,nvar)
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
c-----------------------------------------------------------------------
c       a(i,j) - array of weights; nu1,nu2 - arrays of numbers of 
c       elements "a", ordered with respect to increasing of weigt;
c       k - dimension of "a" with respect to 1-st index (i=1,...,k; 
c       j=1,2); amax - maximal weight; m - number of sorted elements
c-----------------------------------------------------------------------
        dimension a(nvar,2)
        integer*4 nu1(1),nu2(1)
        m=0
                        do 6 i=1,k
                        do 6 ii=1,2
                if(a(i,ii).gt.amax)     go to 6
                if(m.eq.0)              go to 41
                        do 4 j=1,m
        n1j=nu1(j)
        n2j=nu2(j)
                if(a(i,ii).ge.a(n1j,n2j)) go to 4
                        do 3 jj=j,m
        n1=m+j-jj
        n2=n1+1
        nu1(n2)=nu1(n1)
        nu2(n2)=nu2(n1)
3                       continue
        nu1(j)=i
        nu2(j)=ii
                                go to 5
4                       continue
41                      continue
        m1=m+1
        nu1(m1)=i
        nu2(m1)=ii
5                       continue
        m=m+1
6                       continue
                                        return
                                        end
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
	Subroutine bestsolu(vn1,vn2,eps,am0,nfile,fname,title)
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
        real*4 vn1(3),vn2(3)
        character*12 fname
	character*70 title
	open(nfile,file=fname)
	write(nfile,7777)title
	write(nfile,6666)eps,am0
6666	format('t','Residual=',f5.3,1x,' Mo=',e7.2,'N\\264m')
7777	format('t',a70)
	call NS_ANGLE (vn1,vn2,str1,dip1,slip1,str2,dip2,slip2)
	istrike1=str1+0.5
	idip1=dip1+0.5
	islip1=slip1+0.5*sign(1.,slip1)
	istrike2=str2+0.5
	idip2=dip2+0.5
	islip2=slip2+0.5*sign(1.,slip2)
	write(nfile,8888)istrike1,idip1,islip1,istrike2,idip2,islip2
8888	format('tP1:',i3,'\\312,',i2,'\\312,',i4,'\\312,',
     *	' P2:',i3,'\\312,',i2,'\\312,',i4,'\\312')
	write(nfile,9999)istrike1,idip1,islip1
9999	format('4.2',' 7.5 0',3i5,' 4 0 0')
	close(nfile)
                                                        RETURN
                                                        END
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
        Subroutine equisol(vn1,vn2,eps,am0,nfile,fname)
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
c-----------------------------------------------------------------------
c       Program prepare file for GMT for 2 equivalent nodal plane 
c	solutions.
c-----------------------------------------------------------------------
        real*4 un1(3),un2(3),vn1(3),vn2(3),x(2)
        character*12 fname
	character*70 title
	x(1)=2.7
	x(2)=5.7
	title=
     *	'The best solutions for the SW amplitude spectra inversion'
	open(nfile,file=fname)
	write(nfile,8888)title
	write(nfile,7777)eps,am0
7777	format('t','Residual=',f5.3,1x,' Mo=',e7.2,'N\\264m')
8888	format('t',a70)
                        do 77 nsol=1,2
        i=nsol+1
        r3=(-1)**i
        un1(1)=vn1(1)
        un1(2)=vn1(2)*r3
        un1(3)=vn1(3)*r3
        un2(1)=vn2(1)
        un2(2)=vn2(2)*r3
        un2(3)=vn2(3)*r3
	call NS_ANGLE (un1,un2,str1,dip1,slip1,str2,dip2,slip2)
	istrike1=str1+0.5
	idip1=dip1+0.5
	islip1=slip1+0.5*sign(1.,slip1)
	istrike2=str2+0.5
	idip2=dip2+0.5
	islip2=slip2+0.5*sign(1.,slip2)
	write(nfile,9999)x(nsol),istrike1,idip1,islip1,
     *	istrike1,idip1,islip1,istrike2,idip2,islip2
9999	format(f3.1,' 8.5 0',3i5,' 3 0 0 P1:',i3,'\\312,',i2,'\\312,',
     *	i4,'\\312,',' P2:',i3,'\\312,',i2,'\\312,',i4,'\\312')
77                                      continue
	close(nfile)
                                                        RETURN
                                                        END
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
        Subroutine SOLGR04(vn1,vn2,eps,am0,nfile,fname)
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
c-----------------------------------------------------------------------
c       Program draws 4 equivalent nodal planes solutions.
c-----------------------------------------------------------------------
        real*4 un1(3),un2(3),vn1(3),vn2(3),x(4),y(4)
        character*12 fname
	character*70 title
	x(1)=2.7
	x(2)=5.7
	x(3)=2.7
	x(4)=5.7
	y(1)=8.5
	y(2)=8.5
	y(3)=6.5
	y(4)=6.5
	title=
     *	'The best solutions for the SW amplitude spectra inversion'
	open(nfile,file=fname)
	write(nfile,8888)title
	write(nfile,7777)eps,am0
7777	format('t','Residual=',f5.3,1x,' Mo=',e7.2,'N\\264m')
8888	format('t',a70)
                        do 77 nsol=1,4
        i=(nsol-1)*(nsol-2)/2
        r3=(-1)**i
        i=nsol+1
        r2=(-1)**i
        un1(1)=vn1(1)
        un1(2)=vn1(2)*r3
        un1(3)=vn1(3)*r3
        un2(1)=vn2(1)*r2
        un2(2)=vn2(2)*r2*r3
        un2(3)=vn2(3)*r2*r3
	call NS_ANGLE (un1,un2,str1,dip1,slip1,str2,dip2,slip2)
	istrike1=str1+0.5
	idip1=dip1+0.5
	islip1=slip1+0.5*sign(1.,slip1)
	istrike2=str2+0.5
	idip2=dip2+0.5
	islip2=slip2+0.5*sign(1.,slip2)
	write(nfile,9999)x(nsol),y(nsol),istrike1,idip1,islip1,
     *	istrike1,idip1,islip1,istrike2,idip2,islip2
9999	format(2f4.1,' 0',3i5,' 3 0 0 P1:',i3,'\\312,',i2,'\\312,',
     *	i4,'\\312,',' P2:',i3,'\\312,',i2,'\\312,',i4,'\\312')
77                                      continue
	close(nfile)
                                                        RETURN
                                                        END
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
	subroutine NS_ANGLE (ax_norm,ax_slip,str1,dip1,slip1,str2,dip2,
     *	slip2)
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
	real*4 ax_norm(3),ax_slip(3),str1,dip1,slip1,str2,dip2,slip2,r,
     *	x_norm(3),x_slip(3)
	pi=3.141593
	r=-sign(1.,ax_norm(1))
	x_norm(1)=ax_norm(3)*r
	x_norm(2)=ax_norm(2)*r
	x_norm(3)=-ax_norm(1)*r
        x_slip(1)=ax_slip(3)*r
	x_slip(2)=ax_slip(2)*r
	x_slip(3)=-ax_slip(1)*r
	call DCNSTOAN(x_norm,x_slip,str1,dip1,slip1)
	str1=str1/pi*180.
	dip1=dip1/pi*180.
	slip1=slip1/pi*180.
	r=sign(1.,x_slip(3))
	x_norm(1)=x_norm(1)*r
	x_norm(2)=x_norm(2)*r
	x_norm(3)=x_norm(3)*r
        x_slip(1)=x_slip(1)*r
	x_slip(2)=x_slip(2)*r
	x_slip(3)=x_slip(3)*r
	call DCNSTOAN(x_slip,x_norm,str2,dip2,slip2)
	str2=str2/pi*180.
	dip2=dip2/pi*180.
	slip2=slip2/pi*180.
				RETURN
				END
c--------------------------------------------- in Latenso.lib : DCNSTOAN
	subroutine DCNSTOAN (ax_norm,ax_slip, str,dip,slip)
c-----------------------------------------------------------------------
c	Function ARCTAN is renamed by ARCTANG
c-----------------------------------------------------------------------
		real*4 ax_norm(1),ax_slip(1)
		real*4 str,dip,slip
			real*4 v_str(3)
c-----------------------------------------------------------------------
c			From "Normal_Slip" axes to "Double_Couple" angles

c  INPUT  :   ax_norm  - (!!!!) Unic vector in Upper hemisphere
c				( Internal normal of Alachton )
c	      ax_slip  - Slip of Alachton
c				(may be in any hemisphere)

c  OUTPUT :   str  -  strike (azimuth - from North, clockwise,
c					  looking in "strike"_direction
c					  You have Alachton RIGHT_HAND )
c	      dip  -  dip  (always down from horizont, positive)
c	      slip -  slip (from strike, counter clockwise)
c-----------------------------------------------------------------------
	call PLANEBED (ax_norm, str,dip)
						v_str(1)=SIN(str)
						v_str(2)=COS(str)
						v_str(3)=0.

	slip=ARCTANG (RMIX_PRO(ax_norm,v_str,ax_slip),
     *  	     SCAL_PRO(v_str,ax_slip) )
								RETURN
								END
c///////////////////////////////////////////////////////////////////////
c--------------------------------------------- in Latenso.lib : PLANEBED
	subroutine PLANEBED (ax_norm, str,dip)
c-----------------------------------------------------------------------
		real*4 ax_norm(3)
		real*4 str,dip
						data accur /-1.e-6/
	pi=3.141593
c-----------------------------------------------------------------------
c					Strike, Dip by Normal Axis

c  INPUT              :  ax_norm  - may be in any Hemisphere
c  OUTPUT (in Radians):  str  - strike (azimuth - from North, clockwise,
c					  looking in "strike"_direction
c					  You have Alachton RIGHT_HAND )
c		 	 dip  - dip (always down from horizont, positive)
c-----------------------------------------------------------------------
		x=-ax_norm(2)
		y= ax_norm(1)
		z= ax_norm(3)
	if (z.lt.0.) then
		x=-x
		y=-y
		z=-z
	end if
				str=ARCTANG(x,y)
	      if (str.lt.accur) str=str+2.*pi

				dip=ARCTANG(SQRT(x*x+y*y),z)
								RETURN
								END
c///////////////////////////////////////////////////////////////////////
c--------------------------------------------- in Lamedia.lib : ARCTAN
	real*4 function ARCTANG (y,x)
c-----------------------------------------------------------------------
		real*4 y,x
			data accur /1.e-20/
c-----------------------------------------------------------------------
c						Arctan (y/x)
c					result in interval (-pi:pi]
c-----------------------------------------------------------------------
				      ARCTANG=0.
	  if (ABS(y)+ABS(x).gt.accur) ARCTANG=ATAN2(y,x)
								RETURN
								END
c///////////////////////////////////////////////////////////////////////
c--------------------------------------------- in Cochann.lib : MIXEDPRO
	real*4 function RMIX_PRO (vec1,vec2,vec3)
c-----------------------------------------------------------------------
		real*4 vec1(3),vec2(3),vec3(3)
				real*4 vec(3)
c-----------------------------------------------------------------------
c					Return  (vec1,[vec2*vec3])
c-----------------------------------------------------------------------
		  call VECT_PRO (vec2,vec3, vec)
	RMIX_PRO=SCAL_PRO (vec1,vec)
								RETURN
								END
c///////////////////////////////////////////////////////////////////////
c--------------------------------------------- in Cochann.lib : VECTPROD
	subroutine VECT_PRO (v1,v2, vprod)
c-----------------------------------------------------------------------
		real*4 v1(3),v2(3),vprod(3)
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
			x=v1(2)*v2(3)-v1(3)*v2(2)
			y=v1(3)*v2(1)-v1(1)*v2(3)
			z=v1(1)*v2(2)-v1(2)*v2(1)
	vprod(1)=x
	vprod(2)=y
	vprod(3)=z
								RETURN
								END
c///////////////////////////////////////////////////////////////////////
c--------------------------------------------- in Cochann.lib : SCALARPR
	real*4 function SCAL_PRO (vec1,vec2)
c-----------------------------------------------------------------------
		real*4 vec1(3),vec2(3)
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
	SCAL_PRO=vec1(1)*vec2(1)+vec1(2)*vec2(2)+vec1(3)*vec2(3)
								RETURN
								END
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
	subroutine gmt_inp(u,alat,alon,res,resi)
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
	real*4 u(3),res(1)
	r1=1.-1.e-6
	r2=-r1
	resi=1.-res(1)
	x=u(1)
	y=u(2)
	z=u(3)
	pi=3.141593
		if(z.gt.r1) z=r1
		if(z.lt.r2) z=r2
	alat=asin(z)
	alat=180.*alat/pi
	r=sqrt(x**2+y**2)
		if(r.lt.1.e-6) then
		alon=0.
		go to 1
		end if
	y=y/r
	x=x/r
	call arctan(y,x,alon)
1		continue
	alon=alon-pi/2.
	if(alon.gt.pi)alon=alon-2.*pi
	alon=-180.*alon/pi
		return
		end
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
        subroutine ARCTAN(sx,cx,x)
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
c-----------------------------------------------------------------------
c       Sabroutine calculates 0 < Arctg(sx/cx) < 2*pi
c-----------------------------------------------------------------------
                data accur /1.e-6/
        x=abs(sx)
        p=abs(cx)
                if ((x.lt.accur).and.(p.lt.accur)) then
                                                        x=0.
                                                        RETURN
                end if
        p=1.570796327
        pi2=6.283185308
        if(sx)1,2,2
1       is=-1
        go to 3
2       is=1
3       if(cx)4,5,5
4       ic=-1
        go to 6
5       ic=1
6       if(abs(sx)-abs(cx))7,7,8
7       y=sx/cx
        x=atan(y)
                if (y.lt.0.) x=-abs(x)
        x=x+(1-ic)*p
        go to 9
8       y=cx/sx
        x=atan(y)
                if (y.lt.0.) x=-abs(x)
        x=p-x+(1-is)*p
9       if(x)10,10,11
10      x=x+4.*p
11      continue
        x=x-AINT(x/pi2)*pi2
                                                                RETURN
                                                                END
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
	subroutine CPT(fname,nfile,epsmin,vis,nbw)
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
	real*4 epsmin,vis,delta,cpmin,r1,r2
	integer nbw,i1,ic1(11,2),ic2(11,2),ic3(11,2),ic4(11,2),
     *	ic5(11,2),ic6(11,2),ncol
        character*12 fname
	data ic1 /6*255,150,175,170,200,230,
     *	0,25,51,76,102,127,153,178,204,229,240/	
	data ic2 /0,100,150,200,4*255,230,235,255,
     *	0,25,51,76,102,127,153,178,204,229,240/
	data ic3 /255,100,150,0,100,2*150,175,3*255,
     *	0,25,51,76,102,127,153,178,204,229,240/
	data ic4 /5*255,150,175,170,200,2*230,
     *	25,51,76,102,127,153,178,204,229,240,255/
	data ic5 /100,150,200,4*255,230,235,2*255,
     *	25,51,76,102,127,153,178,204,229,240,255/
	data ic6 /100,150,0,100,2*150,175,4*255,
     *	25,51,76,102,127,153,178,204,229,240,255/
	ncol=nbw+1
	open(nfile,file=fname)
	i1=vis*10.+0.5
	delta=0.01*i1
	i1=epsmin*100
	cpmin=0.01*i1
		do i=1,11
	r1=cpmin+delta*(i-1)
	r2=r1+delta
	write(1,100)r1,ic1(i,ncol),ic2(i,ncol),ic3(i,ncol),
     *	r2,ic4(i,ncol),ic5(i,ncol),ic6(i,ncol)
		end do
100	format(f5.2,3(3x,i3),3x,f5.2,3(3x,i3))
	
	close(nfile)
			RETURN
			END
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
        Subroutine N_MECH(vn1,vn2,am0,epsmin,n,numsol,nfile,fname,title)
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
c-----------------------------------------------------------------------
c       Program prepare file to draw 'numsol' focal mechanisms.
c-----------------------------------------------------------------------
        real*4 vn1(n,3),vn2(n,3),am0(n),epsmin(n)
	real*4 un1(3),un2(3),x(8),y(8)
        character*12 fname
	character*70 title
	x(1)=2.7
	x(2)=5.7
	x(3)=2.7
	x(4)=5.7
	x(5)=2.7
	x(6)=5.7
	x(7)=2.7
	x(8)=5.7
	y(1)=8.5
	y(2)=8.5
	y(3)=6.5
	y(4)=6.5
	y(5)=4.5
	y(6)=4.5
	y(7)=2.5
	y(8)=2.5
	open(nfile,file=fname)
	write(nfile,8888)title
8888	format('t',a70)
                        do 77 nsol=1,numsol
	ansol=nsol
	ir=ansol/8.-1.e-5
	isol=nsol-ir*8
        un1(1)=vn1(nsol,1)
        un1(2)=vn1(nsol,2)
        un1(3)=vn1(nsol,3)
        un2(1)=vn2(nsol,1)
        un2(2)=vn2(nsol,2)
        un2(3)=vn2(nsol,3)
	call NS_ANGLE (un1,un2,str1,dip1,slip1,str2,dip2,slip2)
	istrike=str1+0.5
	idip=dip1+0.5
	islip=slip1+0.5*sign(1.,slip1)
	write(nfile,9999)x(isol),y(isol),istrike,idip,islip,nsol,
     *	epsmin(nsol),am0(nsol),istrike,idip,islip
9999	format(f3.1,1x,f3.1,' 0',3i5,' 3 0 0',i3,'.',' @~e@%%=',f5.3,
     *	1x,' Mo=',e7.2,'N\\264m P1:',i3,'\\312,',i2,'\\312,',i4,'\\312')
77                                      continue
	close(nfile)
                                                        RETURN
                                                        END
