//	Spmdlg.h:	Header for InfoViewMDlg class
//=======================================================================

#ifndef SpMDLG_H
#define SpMDLG_H
#include <v/vmodald.h>

    class SpCmdWindow;

    class InfoViewMDlg : public vModalDialog
      {
      public:		//---------------------------------------- public
 
	InfoViewMDlg(vBaseWindow* bw, char* title = "SpePrep V App");
	virtual ~InfoViewMDlg();		// Destructor
	virtual void DialogCommand(ItemVal,ItemVal,CmdType); // action selected
	virtual int SpAction(char* msg);
        void InitDialog();   
 	void Set_List(int,int,int , char **, char **);
       char ProjectFileName[_MAX_FILE_NAME]; 
      char WorkDirName[_MAX_FILE_NAME];
      char WfdiscName[_MAX_FILE_NAME];
      char RootName[_MAX_FILE_NAME];
      char OriginName[_MAX_FILE_NAME];
      char eventInfo[254];
	int  N_ModStaList,N_StaList,N_ModList;
	char ** ModStaList;
	char ** StaList;
	char ** ModList;
	char ** RecordList; // Records in WFdisc
	char ** RecordInList; // Records in Project
	int N_RecPeriodList,N_RecDescrList,
            N_RecordList,N_RecordInList;
	char ** RecPeriodList;
	char ** RecDescrList;

	char ** InfoModStaList;
	char ** InfoStaList;
	char ** InfoModList;
	char ** InfoRecordList; 
	char ** InfoRecordInList; 
	char ** InfoRecPeriodList;
	char ** InfoRecDescrList;	

     float PhVelTmin;
     float ComTmin;
     float CorrComTmin;
     float ComTmax;
     float CorrComTmax;
     int   NPoints;
     int   TotalNum;
     long  N2N;
     int   PhVelCheck;
	float StartDepth;
        float StepDepth;
        int   N_StepDepth;
float dip0,ddip,strik0,dstrik,slip,dslip,angl,dangl;
int ndip,nstrik,nslip,nangl;

int PT_axes;
float PT_az,PT_dev,PT_min;

int variantDefinitionPolari;
float minimumValuePolari;
float pWaveVelocityValue;

char *nameSourceModel;
int  indPolarityScheme;

int EnablePolari;
int EnableMomTens;
      protected:	//--------------------------------------- protected


      private:		//--------------------------------------- private

	SpCmdWindow* _myCmdWin;
      };
#endif

