#ifndef SpPrSave_H
#define SpPrSave_H

#include <string.h> 
#include <sys/param.h>
#include <unistd.h>

class CSpPrSave 
{
  public :
  char m_Comment[128];
  char m_WorkDir[_MAX_FILE_NAME];
  char m_DbeName[_MAX_FILE_NAME];
   char m_DbeRootName[_MAX_FILE_NAME];
   char m_DbeOriginName[_MAX_FILE_NAME];
  int  N_ModStaList;
  int  N_StaList;
  int  N_ModList;
  char ** ModStaList;
  char ** StaList;
  char ** ModList;
char ** RecordList;
char ** RecordInList;
int N_RecordList;
int N_RecordInList;
        int  N_RecPeriodList;
         int  N_RecDescrList;
         int  N_CombN2NList;
         char ** RecPeriodList;
         char ** RecDescrList;
         char **CombN2NList;

     float PhVelTmin;
     float ComTmin;
     float CorrComTmin;
     float ComTmax;
     float CorrComTmax;
     int   NPoints;
     int   TotalNum;
     long  N2N;
     int   PhVelCheck;
	float StartDepth;
        float StepDepth;
        int   N_StepDepth;
float dip0,ddip,strik0,dstrik,slip,dslip,angl,dangl;
int ndip,nstrik,nslip,nangl;

int PT_axes;
float PT_az,PT_dev,PT_min;

	float   m_dw;    
	int m_nitems ; 
        float   m_dt;           
	float * m_w_min;  
	float * m_w_max;   
	float * m_t_min;  
	float * m_t_max;	 
	float * m_dw0; 
	int   * m_ipoint; 

int EnablePolari;
int  indPolarityScheme;
float pWaveVelocityValue;
int variantDefinitionPolari;
float minimumValuePolari;

int EnableMomTens;
	 
char *nameSourceModel;


  CSpPrSave();
  CSpPrSave(char *Name,char *Outerr,char *nameModel,int polarityScheme,
		float pWaveVelocityValue);
  virtual ~CSpPrSave();
  int SaveAs(char *,char *);

//  void Set_StaList(char **);
//  void Set_ModList(char **);
//  void Set_ModStaList(char **);
//        void Set_RecPeriodList(char **);
//        void Set_RecDescrList (char **);
//        void Set_CombN2NList  (char **);
 //       void Set_RecordList  (char **);
 //       void Set_RecordInList  (char **);
//int Set_PreSpeArray(float *,float *,float *,float * ,float *,int *);

};
#endif
