//	SpPrmdlg.h:	Header for SpePrepModalDialog class
//=======================================================================

#ifndef SpePrepMDLG_H
#define SpePrepMDLG_H

#include <v/vmodald.h>
    class SpePrepCmdWindow;

    class SpePrepModalDialog : public vModalDialog
      {
      public:		//---------------------------------------- public
                       
                        SpePrepModalDialog(vBaseWindow* bw, char* title = "Spectra Preparation V App");
	virtual ~SpePrepModalDialog();		// Destructor
	virtual void DialogCommand(ItemVal,ItemVal,CmdType); // action selected
	virtual int SpePrepAction(char* msg);
        
        void Set_ModStaList(char **,int N);
        void Set_StaList(char **, int N);
        void Set_ModList(char **, int N);
        char ** Get_ModStaList() {return ModStaList ;};
        char ** Get_StaList() {return StaList;};
        char ** Get_ModList() {return ModList;};
         int   Get_N_ModStaList()   { return  N_ModStaList;};
         int   Get_N_StaList      ()    { return N_StaList;        };
         int   Get_N_ModList    ()    { return N_ModList;       };
         void Set_Control(int Con)  {Control = Con ;};
          int Get_Control(){return Control;};
          int CalculateModels(char * OutErr);
          int Get3SmacSourceModel(char * OutErr);

          CDbeSeis *pCDbeSeis;
	  char *m_WorkDir;
	  char *nameSourceModel;

      protected:	//--------------------------------------- protected

      private:		//---------------------------------------private 
         int Control; 
         int  N_ModStaList;
         char **ModStaList;
         char **OldModStaList;
          int  N_StaList;
         char **StaList;
          int  N_ModList;
         char **ModList;
         int indSourceModel; // 0 - Model List 1 - 3Smac
        SpePrepCmdWindow* _myCmdWin;
      };

  
#endif

