//
// C++ Interface: models
//
// Description:
//
//
// Author: fmt <fmt@localhost.localdomain>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef MODELS_IMPLEMENTATION_H
#define MODELS_IMPLEMENTATION_H
#include "ui_models.h"
#include "projectwizard.h"
bool hasModelFiles ( QString directory,QStringList &list,int &nummodel );
class LineDocProperty;
class PropertyValue;
class MDocument;
class ModelsPageImpl : public QDialog, private Ui::ModelsBase {
    Q_OBJECT

public:
    ModelsPageImpl ( QWidget *parent,MDocument* doc,ProWizard::DocumentUsing documentUsing );
    void FinishWizard();
    void GetDocumentFromDialog();
    bool CheckDialogParameeters();
    void SetModelStationLists();
    void SetStationLists();
private slots:
    void browse();
    void get3smacmodel();
    void getsourcemodel();
    void doubleClickModelList ( QListWidgetItem *item );
private:
    MDocument* doc;
    ProWizard::DocumentUsing documentUsing;
    void InitDialog();
    void SetDocumentToDialog();
    bool CheckExistModlInlistStationModel ();
    void SetAllLists ( QString &dir );
    QList<PropertyValue* > values;
    QList<LineDocProperty* > propDocLine;
    QString ModelDirectoryName;
    QStringList modelList;
};
#endif
