//
// C++ Interface: grid
//
// Description: 
//
//
// Author: fmt <fmt@localhost.localdomain>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//

#ifndef GRID_IMPLEMENTATION_H
#define GRID_IMPLEMENTATION_H
#include "ui_grid.h"

class LineDocProperty;
class PropertyValue;
class MDocument;

class GridImpl : public QDialog, private Ui::GridBase {
    Q_OBJECT

public:
    GridImpl(QWidget *parent,MDocument* doc);
    void FinishWizard();
    bool CheckDialogParameters();
private:
    MDocument* doc;
    void InitDialog();
    void SetDocumentToDialog();
    void GetDocumentFromDialog();
    void SetPaletToGroupbox(QGroupBox * groupBox ,bool err);
    QList<PropertyValue* > values;
    QList<LineDocProperty* > propDocLine;
};

#endif
