# This is the enviroment variables for source distributions.
# One must edit it in according with your system settings.

# This file should be sourced to properly setup the environment for
# the PASSCAL Datascope Seismic Application Package (DSAP).

source /opt/dsap/3.4/setup.csh

# The FMT software should be installed under the absolute path /opt/fmt

setenv FMT /opt/fmt

setenv FMT_ARCHITECTURE_   linux


# Here is LIBRARY_PATH for dsap, X11, vc++  and GMT
# Compare this LD_LIBRARY_PATH variable with LD_LIBRARY_PATH from your .cshrc(.tcshrc)
# hidden file from your home directory

if ( $FMT_ARCHITECTURE_ =~ linux ) then
setenv INCDIR_X11 /usr/include
setenv LIBDIR_X11 /usr/lib
endif

setenv HOMEVCRV_   /usr/local/v/vgui
setenv GMTHOME     /usr/local/GMT3.4
setenv F2C         /usr/local/f2c
setenv FORTRAN77   /usr/local/fortran77


  if ($?LD_LIBRARY_PATH) then
   setenv LD_LIBRARY_PATH $DSAP/lib:$F2C/lib:$LIBDIR_X11/:$HOMEVCRV_/lib:$LD_LIBRARY_PATH
  else
    setenv LD_LIBRARY_PATH $DSAP/lib:$F2C/lib:$LIBDIR_X11/:$HOMEVCRV_/lib 
   endif 


set path=($FMT/bin $F2C/bin $FORTRAN77/bin  $GMTHOME/bin $path)

if ( $?MANPATH ) then
setenv MANPATH $FORTRAN77/man:$MANPATH
else
# print location of man page(s) that would be displayed onl:
# man -W
setenv MANPATH $FORTRAN77/man:/usr/local/share/man:/usr/share/man/en:/usr/share/man:/usr/X11R6/man
endif



