//Added by qt3to4:
#include <QGridLayout>
#include <QLabel>
#include <QFrame>
#include <QCloseEvent>
#include <vector>
using namespace std;

const double _A4_PAGE_HEIGHT_WIDTH_RATIO = 210./297.;

class BodePlot;
class QAction;
class QLabel;
class QGridLayout;
class QGroupBox;
class QFrame;
class QComboBox;
class CProject;
class CDataInfo;
class CDataSet;

typedef vector< vector<CDataSet* >::iterator >::iterator itPlot;
class GraphWin :   public QWidget
{
        Q_OBJECT
public:
     GraphWin(QWidget *p ,CDataInfo* dataInfo,itPlot it1, itPlot it2,int indNormalization);
     ~GraphWin();
     void ChangeFont(QFont f);
     vector<BodePlot* > vBodePlot;
     vector<QFrame* > vFrame;    
     QGroupBox*   groupBox;
     QGridLayout* MainWindowLayout;   
     QGridLayout* groupBoxLayout; 
    QString header;
    QString footer;  
     
private:
    QLabel* textLabel1;
    QLabel* textLabel2;
    CProject* project;
    CDataInfo* dataInfo;
    int indNormalization;
    int numRow;
    int numCol;
    int numCurve;

};

