#include <QMap>
#include <qwt_plot.h>
#include <qwt_data.h>
#include <math.h>
//-----------------------------------------
#include <qwt_scale_draw.h>
//	#include <qwt_dimap.h>
#include <qwt_plot_printfilter.h>
#include <qwt_array.h>

//-------------------------------------------
/////////////////////////////////////////////////////////////////
class QColor;
class CDataSet;
class CDataInfo;
class QwtPlotCurve;
class QwtPlotMarker;
//------------------------------------------------------------------
class QPainter;
//------------------------------------------------------------------
class CdScaleDraw: public QwtScaleDraw {
public:
    CdScaleDraw(QColor col);
    void    draw(QPainter *, const QPalette &) const;



private:
    QColor  color;
};
class BodePlotHide: public QwtPlot {
    Q_OBJECT
public:
    BodePlotHide(QWidget *parent, CDataSet* data,CDataInfo* dataInfo,int indNormalization);
    void NormalizationCurve(double *y,double* Y,double maxY,int n);
    virtual     ~BodePlotHide();

private:
    CDataSet* data;
    CDataInfo* dataInfo;
    int indNormalization;
};
class BodePlot: public QwtPlot {
    Q_OBJECT
public:
    BodePlot(QWidget *parent,CDataSet* data,CDataInfo* dataInfo,QString name,int indNormalization,bool prn = false);
    void NormalizationCurve(double *y,double* Y,double maxY,int n);
    virtual     ~BodePlot();
//      void drawContents(QPainter *p);
//  void printCanvas(QPainter *, const QRect &, const QwtArray<QwtDiMap> &, const QwtPlotPrintFilter &) const;
    void   printCanvas(QPainter *p, const QRect &br,const QRect &r, const QwtScaleMap m[axisCnt], const QwtPlotPrintFilter & f) const;
    void   ChangeFont(QFont& f);
private:
    CDataSet* data;
    CDataInfo* dataInfo;
    int indNormalization;
    bool prn;
    QwtPlotMarker* mrk1, *mrk2,*mrk3,*mrk4;
    QString titleStr;
};

