#include <QString>
#include <QVector>
#include <QDir>
#include <QStringList>
#include <float.h>

extern QString M0MTENS_ROOT_PATH;
extern QString M0MTENS_SEARCH_HELP_PATH;


static const  QString USER_HOME_PATH = QDir::homePath();

const QString  userHomePath()               { return USER_HOME_PATH;}

const QString  rootPath()                  { return M0MTENS_ROOT_PATH;}
const QString  searchHelpPath()            { return M0MTENS_SEARCH_HELP_PATH;}

static const  QString MAIN_WINDOW_CAPTION = "Comparison of synthetic & observed SW Spectra";
const QString  mainWindowCaption()                  { return MAIN_WINDOW_CAPTION; }

static const  QString MOMENT_TENSOR_PROFILE_NAME = "observed&synthetic moment tensor";
const QString  momentTensorProfileName()    { return MOMENT_TENSOR_PROFILE_NAME ; }

static const  QString MOMENT_TENSOR_LOCATOR_FILE_NAME = "_obs _cal";
const QString  momentTensorLocatorFileName()    { return MOMENT_TENSOR_LOCATOR_FILE_NAME ;   }


static const  QString SECOND_MOMENT_PROFILE_NAME =  "observed&synthetic second moment";
const QString  secondMomentProfileName()                  { return SECOND_MOMENT_PROFILE_NAME ;         }

static const  QString SECOND_MOMENT_LOCATOR_FILE_NAME = " m1oa_t inca_t fica_t ";  // "fi in m1";
const QString  secondMomentLocatorFileName()                  { return SECOND_MOMENT_LOCATOR_FILE_NAME ;      }


