//	DrawCanv.h:	Header for CDrawIntervalsPane class
//=======================================================================

#ifndef myCNV_H
#define myCNV_H
#include "seis.h"

#include <v/vcanvas.h>
#include <v/vmemdc.h>
#include <v/vprintdc.h>
const float X_velocity_min = 2.0;
const float X_velocity_max = 10.0;
const float Y_velocity_min = 2.0;
const float Y_velocity_max = 10.0;
const int N_X_Point = 72;
    class CDrawIntervalsPane : public vCanvasPane
      {

      public:		//---------------------------------------- public
int Rx; int Ry; int Rw; int Rh;
int rx; int ry; int rw; int rh;

 int PrinterMargin;
 int DisplayMargin;
 int TitleMargin;

long Max_Nsample;
float D_X,D_Y,Min_X,Min_Y,Max_X,Max_Y;        
long  N_X;
int LCurves;
int RCurves;
int NLPages;
int NRPages;
int NPages;
int N_Frame_per_Page;
int N_Frame;
int CurPage;
double EvM_T;
double EvS_T;

SET_SEI  *ps;
char **StaList;
int *IndStaAz;
int N_StaList;
int DrawInd;
int ItVal;
int NMainShock;
float ***est ; //Ev_Sta;  
float **set; //Sta-Ev; 
double *set_T; 
 vMemoryDC* myMemDC;     
	CDrawIntervalsPane();
	virtual ~CDrawIntervalsPane();
        void Print();
        //void DrawShapes(vDC* );
          void DrawShapes(vMemoryDC* , vPrintDC* ,int );

	// Scrolling
	virtual void HPage(int shown, int top);
	virtual void VPage(int shown, int top);

	virtual void HScroll(int step);
	virtual void VScroll(int step);

	// Events
	virtual void MouseDown(int x, int y, int button);
	virtual void MouseUp(int x, int y, int button);
	virtual void MouseMove(int x, int y, int button);

	virtual void Redraw(int x, int y, int width, int height);
	virtual void Resize(int newW, int newH);
int InitDrawing(char *) ;
long GetXindexFromXDisplay (int  ,vRect ); 
int  GetXDisplayFromXindex (long ,vRect );
int  GetXDisplayFromX      (float,vRect ); 
int  GetYDisplayFromY      (float,vRect ); 

      protected:	//--------------------------------------- protected

      private:		//--------------------------------------- private
      };
#endif
