//	DrawCnvCmd.h:	Header for myCmdWindow class
//=======================================================================

#ifndef myCMDW_H
#define myCMDW_H

#include <v/vcmdwin.h>	// So we can use vCmdWindow
#include <v/vmenu.h>	// For the menu pane
#include <v/vutil.h>	// For V Utilities
#include <v/vcmdpane.h> // command pane
#include <v/vstatusp.h>	// For the status pane
#include <v/vtimer.h>	// Timer

#ifdef vDEBUG
#include <v/vdebug.h>
#endif

//#include "seis.h"
#include "DrawCanv.h"


    class myCmdWindow;

    
    class myCmdWindow : public vCmdWindow
      {
	friend int AppMain(int, char**);	// allow AppMain access

      public:		//---------------------------------------- public
	myCmdWindow(char*, int, int,SET_SEI *,char**,int ,int,int);
	virtual ~myCmdWindow();
	virtual void WindowCommand(ItemVal id, ItemVal val, CmdType cType);
	virtual void KeyIn(vKey keysym, unsigned int shift);
      protected:	//--------------------------------------- protected

      private:		//--------------------------------------- private

	// Standard elements
	CDrawIntervalsPane   * CDrawIntervalsCanvasPane;		// For the canvas
	vCommandPane* CDrawCmdPane2;	// for the command pane

	// Dialogs associated with CmdWindow

	//myDialog* myDlg;

      };
#endif
