//	FmtEcmdw.h:	Header for FmtOriginCmdWindow class
//=======================================================================

#ifndef FmtOriginCMDW_H
#define FmtOriginCMDW_H
const int _MAX_FILE_NAME  = 200;

#include <v/vcmdwin.h>	// So we can use vCmdWindow
#include <v/vmenu.h>	// For the menu pane
#include <v/vutil.h>	// For V Utilities
#include <v/vcmdpane.h> // command pane
#include <v/vstatusp.h>	// For the status pane
#include <v/vtimer.h>	// Timer
#include <v/vfilesel.h>
#include <v/vynreply.h>

#include <ctype.h>
#include <string.h>
   static int SaveAsfilterIndex = 1;
    static char* SaveAsfilter[] =
      {
            "*",
            "*.sac",              
            
        0
      };


#ifdef vDEBUG
#include <v/vdebug.h>
#endif
void Delete2DCharArray(int numberString,char **&Char2DArray);
void Delete2DFloatArray(int firstDimention,float **&float2DArray);
void Delete3DFloatArray(int firstDimention,int secondDimention,float ***&float3DArray);

void sort(int ,char ** ) ;
void StrToUpper(char *);
void StrToLower(char *);
int Is_Digit(char *);
int Is_ZDigit(char *);


#include "SpeDbname.h"
#include "SpPrSave.h"
//#include "SpPrdbe.h"    // Dbe 
#include "DrawCnvCmd.h"
    class FmtOriginCmdWindow;

    class FmtOriginTimer : public vTimer
      {
      public:		//---------------------------------------- public
	FmtOriginTimer(FmtOriginCmdWindow* cw) { cmdw = cw; }
	~FmtOriginTimer() {}
	virtual void TimerTick();
      private:		//--------------------------------------- private
	FmtOriginCmdWindow* cmdw;
      };

    class FmtOriginCmdWindow : public vCmdWindow
      {
	friend int AppMain(int, char**);	// allow AppMain access

      public:		//---------------------------------------- public
	FmtOriginCmdWindow(char*, int, int, int, int);
	virtual ~FmtOriginCmdWindow();
	virtual void WindowCommand(ItemVal id, ItemVal val, CmdType cType);
	virtual void KeyIn(vKey keysym, unsigned int shift);
        int filterDblClick(ItemVal , int &);
        ORIG ori;
	    char OriginName[_MAX_FILE_NAME];
	    char DirSacName[_MAX_FILE_NAME];

		void EmptyOrigin();

      protected:	//--------------------------------------- protected
int itsNumberSacRecords;
int  N_EventList,N_StaList,N_SelStaList,N_OldSelStaList,NMainShock;
char ** EventList;
char ** StaList;
char ** SelStaList;
char ** OldSelStaList;
int IndicateSave;
    char ErrorReturnCode[4096];

      private:		//--------------------------------------- private
	int Ww, Hh;
	// Standard elements
	vMenuPane* FmtOriginMenu;		// For the menu bar
	vCommandPane* FmtOriginCmdPane;	// for the command pane
	vCommandPane* FmtOriginCmdPane2;	// for the command pane

	vStatusPane* FmtOriginStatus;		// For the status bar
	FmtOriginTimer* _timer;	// Timer for Date/Time
	

        SpDbNameModalDialog*  SpeDbNameDialog;
         CSpPrSave  *pSpPrSave; 
         SET_SEI    *pSET_SEI;
        char CSpPrSaveName[256];  
	char m_WorkDir[_MAX_FILE_NAME];
char InFileRecordsTemp[64];
char OutFileRecordsTemp[64];

	// Dialogs associated with CmdWindow

int     DblEventList,DblStaList, DblSelStaList,DblOK; 
void  Set_SelStaList(char **, int);
void  Save_SelStaList();
int   GetLists(char *);
void  Get_NewSelStaLists();
int   GetEventList(char *OriginName,char *ErrorReturnCode);
char* GetProjectWfdisc(char *);
void  DrawMap(char *);
void  DeleteSET_SEI(SET_SEI *&pSET_SEI);
      };
#endif
