//	SpPrcnv.h:	Header for SpePrepTextCanvasPane class
//=======================================================================
#ifndef SpePrepTCNV_H
#define SpePrepTCNV_H

#include <v/vtextcnv.h>

    class SpePrepTextCanvasPane : public vTextCanvasPane
      {
      public:		//---------------------------------------- public
	SpePrepTextCanvasPane();
	virtual ~SpePrepTextCanvasPane();
	// Scrolling
	virtual void HPage(int, int);
	virtual void VPage(int, int);

	virtual void HScroll(int);
	virtual void VScroll(int);
         char *Get_TextOut();
         void  Set_TextOut(char *);
         void  Cat_TextOut(char *);


	// Events
	virtual void FontChanged(vFont& newFont);
	virtual void ResizeText(const int rows, const int cols);

	virtual void Redraw(int x, int y, int w , int h);
	virtual void TextMouseDown(int row, int col, int button);
	virtual void TextMouseUp(int row, int col, int button);
	virtual void TextMouseMove(int row, int col, int button);


      protected:	//--------------------------------------- protected
      private:		//--------------------------------------- private
      char *TextOut;
      };
#endif

