#include <time.h> 
#include <string.h> 
#include <stdlib.h>  
#include <errno.h>  
#include <stdio.h>            
#include <math.h> 
#include <ctype.h>
#include "SpPrcmdw.h"	// our header
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>
#include <v/vnotice.h>	// for vNoticeDialog
extern int VERSIONMOMTENS;
const float Pi  = 3.1415926; 
const float Pi2 = 6.2831852; 
  
extern        char  *Att_String_List1   []; 
extern        char  *Att_Prem_structure []; 
extern        char  *Att_String_List2   []; 
extern        char  *Att_String_List3   []; 
extern        char  *Att_String_List4   [];  
extern        char  *Att_String_List5   [];        
char **List_Mod_Phvel; 
int   Number_List_Mod_Phvel; 

float AMPz, AMPe, AMPn;
extern "C" { 
double fmtepoph();
void fmtetoh(double,int *,int *,int *,int *,int *,int *,float *);

void fmtdoy2mday(); 

extern int specprep_(long *,float *,float *,float *,float *,float *, 
 
long *,float *,float *,long*,float *,float *,long*,char *,float *,float *, 
char * ,long*,float *,float *,float *,long*,long*,float* ,float  *,
float  *);
extern  int qmain_(long *);
extern int intpol1_(float *,float *, long*,float*,float*,long*);

}
union unSet
{
 float fal;
 int val;
 char ch[4];
};
float DecoderPcUnix(float inFloat);
int   DecoderPcUnix(int inInt);
int   DecoderPcUnix(int inInt) {
unSet inSet;
//  0 1 2 3 
//  3 2 1 0
inSet.val = inInt;
char wch[2];
wch[0]= inSet.ch[0];
wch[1]= inSet.ch[1];
inSet.ch[0] = inSet.ch[3];
inSet.ch[1] = inSet.ch[2];
inSet.ch[2] = wch[1];
inSet.ch[3] = wch[0];
return inSet.val;
}
float DecoderPcUnix(float inFloat){
unSet inSet;
char wch[2];
inSet.fal = inFloat;
wch[0]= inSet.ch[0];
wch[1]= inSet.ch[1];
inSet.ch[0] = inSet.ch[3];
inSet.ch[1] = inSet.ch[2];
inSet.ch[2] = wch[1];
inSet.ch[3] = wch[0];
return inSet.fal;
}
void TransformFloatArray(float *s,long n);
void TransformFloatArray(float *s,long n){
    for(long i = 0; i < n; i++) s[i] = DecoderPcUnix(s[i]);


}

 
int SpePrepCmdWindow::OnCalcSpe(char *ErrorReturnCode) 
{ 
        char text[256];  
        char name_curr_dir[_MAX_FILE_NAME];    
        char s2[_MAX_FILE_NAME]; 
	char backslash = 0x5c;


     if ( chdir(m_ResultDir) == -1 )
     if(mkdir(m_ResultDir, 0777) == -1) {
          sprintf(ErrorReturnCode, "System Error: Cannot create directory\n   %s",m_ResultDir);
          return 1;
     } else chdir(m_ResultDir);


strcpy(Dir_mom_tens,m_ResultDir); strcat(Dir_mom_tens,"/MOM_TENS");
strcpy(Dir_result,m_ResultDir); strcat(Dir_result,"/RESULTS");
strcpy(Dir_obs_calc,m_ResultDir); strcat(Dir_obs_calc,"/OBS_CALC");


     if ( chdir(Dir_mom_tens) == -1 )
     if(mkdir(Dir_mom_tens, 0777) == -1) {
          sprintf(ErrorReturnCode, "System Error: Cannot create directory\n   %s",Dir_mom_tens);
          return 1;
     } else chdir(Dir_mom_tens);

sprintf(text,"%crm ???mod1",backslash);
     system(text);
sprintf(text,"%crm ???_cal",backslash);
     system(text);
sprintf(text,"%crm ???_obs",backslash);
     system(text);


     if ( chdir(Dir_result) == -1 )
     if(mkdir(Dir_result, 0777) == -1) {
          sprintf(ErrorReturnCode, "System Error: Cannot create directory\n   %s",Dir_result);
          return 1;
     } else chdir(Dir_result);

/*
     if ( chdir(Dir_obs_calc) == -1 )
     if(mkdir(Dir_obs_calc, 0777) == -1) {
          sprintf(ErrorReturnCode, "System Error: Cannot create directory\n   %s",Dir_obs_calc);
          return 1;
     } else chdir(Dir_obs_calc);

*/
strcpy(Dir_maps_ps,Dir_result); strcat(Dir_maps_ps,"/MAPS.PS");
strcpy(Dir_mecha_ps,Dir_result); strcat(Dir_mecha_ps,"/MECHA.PS");
strcpy(Dir_depth_ps,Dir_result); strcat(Dir_depth_ps,"/DEPTH.PS");
strcpy(Dir_obs_calc_ps,Dir_result); strcat(Dir_obs_calc_ps,"/OBS_CALC.PS"); 
strcpy(Dir_polarity_ps ,Dir_result); strcat(Dir_polarity_ps,"/POLARITY.PS");

 if ( VERSIONMOMTENS == 1 ) {
	strcpy(Dir_angle_ps,Dir_result); strcat(Dir_angle_ps,"/ANG_DC.PS");

     if ( chdir(Dir_angle_ps) == -1 )
     if(mkdir(Dir_angle_ps, 0777) == -1) {
          fprintf(stderr, "System Error: Cannot create directory\n   %s",Dir_angle_ps);
          return 1;
     } else chdir(Dir_angle_ps);
 } // VERSIONMOMTENS == 1


     if ( chdir(Dir_maps_ps) == -1 )
     if(mkdir(Dir_maps_ps, 0777) == -1) {
          sprintf(ErrorReturnCode, "System Error: Cannot create directory\n   %s",Dir_maps_ps);
          return 1;
     } else chdir(Dir_maps_ps);


     if ( chdir(Dir_mecha_ps) == -1 )
     if(mkdir(Dir_mecha_ps, 0777) == -1) {
          sprintf(ErrorReturnCode, "System Error: Cannot create directory\n   %s",Dir_mecha_ps);
          return 1;
     } else chdir(Dir_mecha_ps);


     if ( chdir(Dir_depth_ps) == -1 )
     if(mkdir(Dir_depth_ps, 0777) == -1) {
          sprintf(ErrorReturnCode, "System Error: Cannot create directory\n   %s",Dir_depth_ps);
          return 1;
     } else chdir(Dir_depth_ps);


     if ( chdir(Dir_obs_calc_ps) == -1 )
     if(mkdir(Dir_obs_calc_ps, 0777) == -1) {
          sprintf(ErrorReturnCode, "System Error: Cannot create directory\n   %s",Dir_obs_calc_ps);
          return 1;
     } else chdir(Dir_obs_calc_ps);

     if ( chdir(Dir_polarity_ps) == -1 )
     if(mkdir(Dir_polarity_ps, 0777) == -1) {
          sprintf(ErrorReturnCode, "System Error: Cannot create directory\n   %s",Dir_polarity_ps);
          return 1;
     } else chdir(Dir_polarity_ps);

strcpy(Dir_mom_tens,m_ResultDir); strcat(Dir_mom_tens,"/MOM_TENS");

chdir(Dir_mom_tens);


                               
         strcpy(s2,Dir_mom_tens); 
         strcat(s2,"/protocol.txt"); 
         FILE *out,*att,*f; 
          
                if((out = fopen(s2,"w")) == NULL) { 
                sprintf(ErrorReturnCode,"OnCalcSpe()\nCannot open file \n'%s'",s2);
                return 1; 
                         }                           
         strcpy(s2,Dir_mom_tens); 
         strcat(s2,"/bpsq.inp");   
         char Att_Name_Inp[_MAX_FILE_NAME];   
         strcpy(Att_Name_Inp,s2); 

                                       int i,j,k,m,q; 
 
   SET_SEI *ps = pCDbeSeis->ps;
   int n_sei = ps->n;
   SEI **sei = ps->sei;
   SEI *wf;
   
                         char *ptr = 0; 
                         float az; 
                         //float amp,amp1,amp2,dist,aztos,azfrs; 
                         //float zer[20][2]; long nzer;  int inzer; 
                         //float pol[50][2]; long npol;  int inpol;    
        List_Mod_Phvel = new char *[n_sei]; 
        for ( int jh1 = 0; jh1 <  n_sei; jh1++)  
           List_Mod_Phvel[jh1] = new char [36]; 
                m_nff = N2N;
                m_npoints = NPoints;         

		float   * mre  = new float  [m_nff]; 
		float   * mim  = new float  [m_nff];  
		float   * mreu = new float  [m_npoints]; 
		float   * mimu = new float  [m_npoints]; 
		float   * mw   = new float  [m_npoints]; 
		float   * mamp = new float  [m_npoints]; 
		float   * mpha = new float  [m_npoints];	
		m_tmin_com_e = CorrComTmin; 
		m_tmax_com_e = CorrComTmax; 
                m_phvmax = PhVelTmin;
	 long ierr;
                                               char WStr[24];
		                               int n_eq_items = N_ModStaList; 
		                               int n_w_items  = N_RecDescrList; 
		                               char WSeis_name[24]; 
		                               char Model_Name[9],Station_Name[9], 
		                                    Seis_Name[24],Loop_Seis_Name[24]; 
		                               int ind_lr;      
		                          char Att_lr[2];  
                                  int   Att_n,jk; 
                                  float Att_dw,Att_wmax,Att_wmaxw,Att_wminw; 
                                  float Att_wmaxw_i[2],Att_wminw_i[2];  
                                  int Att_micomp[2],i1,  i2,  i3,  i4; 
                                  float f1,f2,f3,f4,f_m; 
                   int N_Att_File; 
                   char Comp_Sei_Name[24]; 
       int n1_i,i_l; 
       char **Att1_buffer = new char *[m_npoints + 1];   
       for (i_l = 0; i_l <= m_npoints; i_l++)          
       Att1_buffer[i_l] = new char [80];                     
       float step_w;                                
             q = 0; 
            N_Att_File = 0;                            
while ( strstr(Att_Prem_structure[q],"#") == NULL) { 
                N_Att_File++;   q++; 
 }                                   
 
             q = 0; 
while ( strstr(Att_String_List5[q],"#") == NULL) {    
                N_Att_File++;   q++; 
      }                                               
       
 N_Att_File += 20 +  5*n_eq_items; 
 
char ** Att_Mem  = new char *[N_Att_File]; 
       for (q = 0; q< N_Att_File; q++) 
            Att_Mem[q]  = new char [80]; 
                                    
         Att_n     = 0;       
               for ( j = 0; j <  n_w_items; j++){    
                      
                 sscanf(RecDescrList[j],"%s%e%ld%e", 
                 Seis_Name,&mtmin,&mipoint,&mtmax);          
                 if ( (int )mipoint > Att_n)  Att_n = (int )mipoint; 
                                                 } 
                   int N_String_in_Att_File = 0; 
                              
        step_w =  Att_dw    = (Pi2/m_tmin_com_e - Pi2/m_tmax_com_e)/( m_npoints - 1 ); // Att_n 
         Att_wmax  =  Pi2/m_tmin_com_e;  
         Att_wmaxw =  Pi2/m_tmin_com_e +   3e-4; 
         Att_wminw =  Pi2/m_tmax_com_e -   3e-4;                                   
int    P = 0; 
                sprintf(Att_Mem[P++ ],"%s\n",Att_String_List1[0]); 
                N_String_in_Att_File++; 
                sprintf(Att_Mem[ P++],"%s\n",Att_String_List1[1]); 
                N_String_in_Att_File++;                 
                sprintf(Att_Mem[ P++],"%s\n",Att_String_List1[2]); 
                N_String_in_Att_File++;                 
  
              char c_wmax[8],c_dw[8],c_wmax1[8],c_dw1[8]; 
               
              sprintf(c_wmax,"%7.5f",Att_wmax);  
              sprintf(c_dw,"%7.5f",Att_dw); 
       sprintf(Att_Mem[ P++],"kstr= 1  kmax=%3ld  wmax=%s  dw  =%s  maxLmodes= 1  maxRmodes= 1\n", 
      m_npoints,c_wmax+1,c_dw+1); //  Att_n 
                N_String_in_Att_File++;                        
 
                sprintf(Att_Mem[ P++],"%s\n",Att_String_List1[4]); 
                N_String_in_Att_File++;                                        
                sprintf(Att_Mem[ P++],"%s\n",Att_String_List1[5]);       
                N_String_in_Att_File++;                                        
              sprintf(c_wmax,"%6.4f",Att_wmaxw);  
              sprintf(c_dw,"%6.4f",Att_wminw); 
       sprintf(Att_Mem[ P++]," %s %s\n", 
       c_wmax + 1,c_dw + 1); 
                N_String_in_Att_File++;                               
 
                sprintf(Att_Mem[ P++],"%s\n",Att_String_List1[7]);              
                N_String_in_Att_File++;                                        
                sprintf(Att_Mem[ P++],"%s\n",Att_String_List1[8]); 
                N_String_in_Att_File++;                                        
              sprintf(c_wmax,"%6.4f",Att_wmaxw);  
              sprintf(c_dw,"%6.4f",Att_wminw); 
       sprintf(Att_Mem[ P++]," %s %s\n\n", 
       c_wmax + 1,c_dw + 1);           
                N_String_in_Att_File++;                               
                N_String_in_Att_File++;                                
                 
                 
                 
 q = 0; 
while ( strstr(Att_Prem_structure[q],"#") == NULL) { 
 sprintf(Att_Mem[ P++],"%s\n",Att_Prem_structure[q]);q++;      
                N_String_in_Att_File++;                         
 }                       
 
sprintf(Att_Mem[ P++],"%s\n",Att_String_List2[0]);                       
                N_String_in_Att_File++;                        
sprintf(Att_Mem[ P++],"%s\n",Att_String_List2[1]);                      
                N_String_in_Att_File++;                        
sprintf(Att_Mem[ P++],"%s\n",Att_String_List2[2]);                      
                N_String_in_Att_File++;                        
sprintf(Att_Mem[ P++],"%s\n",Att_String_List2[3]);                      
                N_String_in_Att_File++;                        
 
sprintf(Att_Mem[ P++],"%3d - krec - number of recorders            \n", 
       n_eq_items);                                           
                N_String_in_Att_File++;                               
 
                                 //char work[_MAX_FILE_NAME],str[128]; 
                                // long lh; float *sset; 
//////////////////  FIRST LOOP  ////////////////////////////////// 
fprintf(out,"%s", 
"File: SpeCalw.cpp, Implementation 'OnCalcSpe'  , Program: 'Speprep'" ); 
 fflush(out);                                 
	Number_List_Mod_Phvel  =	  jk = 0;                                   
		for (i = 0; i < n_eq_items; i++) {     
             
         
                // m_lbox_equ.GetText(i,Search_Equ);      
                 sscanf(ModStaList[i],"%s%s", 
                        Model_Name,Station_Name);      
 // 3Smac
if (strcmp(Model_Name,_IND_3SMAC_) == 0)
sprintf(Model_Name,"%s@",Station_Name);
         //////////////////////////// search_sei ///////////// 
         for (j = 0; j <  n_w_items; j++) { 
                 //m_box_w.GetText(j,Search_W);      
                 sscanf(RecDescrList[j],"%s%e%ld%e", 
                 Seis_Name,&mtmin,&mipoint,&mtmax);  
                     strcpy(Comp_Sei_Name,Seis_Name); 
                     *strchr(Comp_Sei_Name,':') = '\0'; 
              if    (strstr(Comp_Sei_Name,Station_Name) != NULL) break; 
         }                        
         //////////////////////////// search_sei /////////////          
          
 Start_Old_Station : ;                                                             
                 strcpy(Loop_Seis_Name, Seis_Name); 
                        *strchr(Loop_Seis_Name,':') = '\0'; 
strcpy(name_curr_dir,pCDbeSeis->Get_DbeName());
*strrchr(name_curr_dir,'/') = '\0';

        chdir(name_curr_dir);  
  
   if ( Read_Seismogram(&k,j,Seis_Name,ErrorReturnCode) ){
	    return 5;

}

    chdir(Dir_mom_tens);

		  mdt      = m_dt;                                 
		  az       = sei[k]->aztos;          
		  if ( az < (float) 0. ) az += (float)360.; 
		for (m = 0 ; m < m_nff; m++) mre[m] = mim[m] = (float)0.;

   	   mlr = 'X';
		for (m = 0 ; m < mnsample; m++) mre[m] = sei[k]->s[m];

		  delete [] sei[k]->s; sei[k]->s = 0;
		  if (sei[k]->comp[0] == 'z' ) {mlr = 'r'; micomp = 1L;} 
		   
		  if (sei[k]->comp[0] == 'r' ) { 
		  mlr = 'r';        
		  if ( az < (float) 45. || az > (float) 315. ||  
		  (az > (float)135. && az < (float)225.)  ) micomp = 2L; 
		     else micomp = 3L; 
                   
		                                 }         
 

	   
		  if (sei[k]->comp[0] == 't' ) { 
		  mlr = 'l'; 
		  if ( az < (float) 45. || az > (float) 315. ||  
		  (az > (float)135. && az < (float)225.)  ) micomp = 3L; 
		     else micomp = 2L;		
			                                  
		                                  } 
 
		 sprintf(mlrfile,"%c%2.2datt1",mlr,i+1);  
	 
 
fprintf(out,"\n%d Name: %s  Model_Name = %s Station_Name = %s Seis_Name = %s\n", 
jk++,mlrfile,Model_Name,Station_Name,Seis_Name); 
sprintf(List_Mod_Phvel[Number_List_Mod_Phvel],"%3.3s %s", 
                                      mlrfile,Station_Name); 


Number_List_Mod_Phvel++; 
fprintf(out,"St:> %s n2n = %ld n_i_point = %ld Aztost = %e\n", 
Loop_Seis_Name,m_nff,mipoint,az);                      
fprintf(out,"lr = %c m_points = %ld T_MIN = %e T_MAX = %e \n", 
mlr,m_npoints , m_tmin_com_e  ,	m_tmax_com_e); 
	   
fprintf(out,"mnsample = %ld mt0 = %e mdt = %e micomp = %ld \n", 
mnsample,mt0,mdt,micomp); 
                 
fflush(out);     
   
       
  // 3Smac
if (strchr(Model_Name,'@') != 0)
fprintf(stderr,"SpeCalc :> Model = 3Smac:> '%s'  Station = '%s' ( #%2d of %d ) Seis = %s\n", 
        Model_Name ,Station_Name,i+1, n_eq_items,Seis_Name); 
else 
fprintf(stderr,"SpeCalc :> Model = '%s'  Station = '%s' ( #%2d of %d ) Seis = %s\n", 
        Model_Name ,Station_Name,i+1, n_eq_items,Seis_Name); 
 
      specprep_(&m_nff,mre,mim,mreu,mimu,mw,&m_npoints,mamp,mpha, 
      &mnsample,&mt0,&mdt,&micomp,&mlr,&m_tmin_com_e  ,&m_tmax_com_e,mlrfile,&mcode_return,
&sei[k]->amp,&sei[k]->dist,
&sei[k]->aztos,&sei[k]->nzer,&sei[k]->npol,
&sei[k]->amp1,&sei[k]->zer[0][0],&sei[k]->pol[0][0]);


		 if ( mcode_return == 1L )  {    
           sprintf( ErrorReturnCode, "Fatal Error: SpecPrep Fortran: Amplitude of respons for %s is 0!",Seis_Name);
           return 11; 
                         } 
 
                                                    
      if (sei[k]->comp[0] == 'r' )   sei[k]->amp = AMPe;      
      if (sei[k]->comp[0] == 't' )   sei[k]->amp = AMPn;                                                                                       
      
                               if (mipoint == 0 ) goto Miss; 

                       
                if((f = fopen(mlrfile,"r")) == NULL) {  
  sprintf( ErrorReturnCode, "Fatal Error: SpeCalw: Cannot open file. \n%s",mlrfile); 
                return 12; 
                         }                           
                                
   
             if( fgets (Att1_buffer[0],80,f) == NULL){ 
    sprintf( ErrorReturnCode,"Fatal Error: SpeCalw: Unexpected end of file found '%s' at : 1 rec",mlrfile);    
                   return 14;       
                                                        
     }                                                   
 
       for (i_l = 1; i_l <= m_npoints; i_l++) {  
      
             if( fgets (Att1_buffer[i_l],80,f) == NULL){     
    sprintf( ErrorReturnCode,"Fatal Error: SpeCalw: Unexpected end of file found '%s' at: %d rec",mlrfile,i_l+1);
                   return 15;       
    }             
                                                } 
 
 
 
 fclose(f);                      

                 if((f = fopen(mlrfile,"w")) == NULL) { 
           sprintf(ErrorReturnCode,"Modul:> OnCalcSpe()\nCannot open file \n'%s' ",mlrfile);
                return 10; 
                         }                            
 
           
           n1_i = (int) (( Pi2/m_tmin_com_e - Pi2/mtmin) / step_w + 0.5); 
              
        fprintf(f,"%s",Att1_buffer[0]); 

 
        for (i_l = n1_i + 1; i_l <= m_npoints; i_l++) { 
         
  fprintf(f,"%s",Att1_buffer[i_l]);                                           
        }        
 fclose(f);   

   Miss:    
                                                            

	if (	++j > n_w_items - 1 ) goto End_Box;     
	 
                 // m_box_w.GetText(j,Search_W); 
                 sscanf(RecDescrList[j],"%s%e%ld%e", 
                 Seis_Name,&mtmin,&mipoint,&mtmax);        
                     strcpy(Comp_Sei_Name,Seis_Name); 
                     *strchr(Comp_Sei_Name,':') = '\0';
                                     
                if ( strstr(Comp_Sei_Name,Loop_Seis_Name) != NULL ) 
                                {goto Start_Old_Station; } 
 
End_Box : ; 
               
        }         

//////////////////  FIRST LOOP  ////////////////////////////////// 
        delete   [] mre; 
        delete   [] mim; 
        delete   [] mreu; 
		delete   [] mimu; 
		delete   [] mw; 
		delete   [] mamp; 
		delete   [] mpha; 
  
                 for (int k10 = 0; k10 <= m_npoints; k10++) 
                 delete [] Att1_buffer[k10];            
                 delete [] Att1_buffer;   



//////////////////  SECOND LOOP  ////////////////////////////////// 
 

 
 
          BOOL LAST_RECORD = FALSE; 
         
		  j = 0;                                   
		for (i = 0; i < n_eq_items; i++) {     
             
         
                 //m_lbox_equ.GetText(i,Search_Equ);      
                 sscanf(ModStaList[i],"%s%s", 
                        Model_Name,Station_Name); 
 // 3Smac
if (strcmp(Model_Name,_IND_3SMAC_) == 0)
sprintf(Model_Name,"%s@",Station_Name);
     
            for (q = 0; q < 2; q++){ 
            Att_wmaxw_i[q] = (float)0.;                         
            Att_wminw_i[q] = (float)0.;                         
            Att_lr[q]      = ' ';      
            Att_micomp[q]  = 0;     
            } 
            ind_lr = 0;      
         //////////////////////////// search_sei ///////////// 
         for (j = 0; j <  n_w_items; j++) { 
                // m_box_w.GetText(j,Search_W);      
                 sscanf(RecDescrList[j],"%s%e%ld%e", 
                 Seis_Name,&mtmin,&mipoint,&mtmax);  
                     strcpy(Comp_Sei_Name,Seis_Name); 
                     *strchr(Comp_Sei_Name,':') = '\0';                         
              if    (strstr(Comp_Sei_Name,Station_Name) != NULL) break; 
         }                        
    
Start_Old_Station1 : ;                                                  
                 strcpy(Loop_Seis_Name, Seis_Name); 
                        *strchr(Loop_Seis_Name,':') = '\0';             
           
          strcpy(WStr,Seis_Name); 
        *(strchr(WStr,':')+1) = tolower(WStr[strlen(WStr)-1]);
        *(strchr(WStr,':')+2) = '\0';
        for (k = 0; k < n_sei; k++){ 
                wf = sei[k];
        sprintf(  WSeis_name,"%s:%s",wf->sta,wf->comp);
    
        if ( (  ptr = strstr (WSeis_name,WStr) ) != NULL) break; 
 
        } 
        		                                                      
        if ( ptr == NULL) { 
                sprintf(ErrorReturnCode,"Error: Not found Sei Record  for  All of Stations!");
                return 3;         
        }	
	   
		  az       = sei[k]->aztos;  
		  if ( az < (float) 0. ) az += (float)360.; 		   
		   
		  if (sei[k]->comp[0] == 'z' ) {mlr = 'r'; micomp = 1L;} 
		   
		   
		   
		  if (sei[k]->comp[0] == 'r' ) { 
		  mlr = 'r';        
		  if ( az < (float) 45. || az > (float) 315. ||  
		  (az > (float)135. && az < (float)225.)  ) micomp = 2L; 
		     else micomp = 3L; 
		                                 } 
		   
		  if (sei[k]->comp[0] == 't' ) { 
		  mlr = 'l'; 
		  if ( az < (float) 45. || az > (float) 315. ||  
		  (az > (float)135. && az < (float)225.)  ) micomp = 3L; 
		     else micomp = 2L;		                                   
		                                  }		   
	   
		  Att_lr[ind_lr] = mlr; 
          Att_micomp[ind_lr] = (int) micomp;      
           
 
 
 
                                    
	if (	++j > n_w_items - 1 ) {LAST_RECORD = TRUE; goto Last_Record1; }    
	 
                 // m_box_w.GetText(j,Search_W); 
                 sscanf(RecDescrList[j],"%s%e%ld%e", 
                 Seis_Name,&mtmin,&mipoint,&mtmax);        
                     strcpy(Comp_Sei_Name,Seis_Name); 
                     *strchr(Comp_Sei_Name,':') = '\0';                         
                if ( strstr(Comp_Sei_Name,Loop_Seis_Name) != NULL ) 
                                {ind_lr++; goto Start_Old_Station1; }  
 Last_Record1 : ;  
////////////////////// Write Att File /////////////////////// 
                              
sprintf(Att_Mem[ P++],"%s\n",Att_String_List3[0]);          
                N_String_in_Att_File++;                        
if (Att_lr[1] != ' ' ){ 
i1 = 1; 
i2 = (int)Att_micomp[0]; 
i3 = 1; 
i4 = (int)Att_micomp[1]; 
}                else    { 
          if (Att_lr[0] == 'l'){ 
            i1 = 1; 
            i2 = (int)Att_micomp[0]; 
            i3 = 0; 
            i4 = 0; 
             }  else  { 
            i1 = 0; 
            i2 = 0; 
            i3 = 1; 
            i4 = Att_micomp[0];              
              
             } 
} 
sprintf(Att_Mem[ P++],"%8.1f%8.4f %4d %4d %4d %4d %4d\n", 
       sei[k]->dist,sei[k]->aztos*Pi2/(float)360, 
       i1,  i2,  i3,  i4,  (int)1);              
                N_String_in_Att_File++;                               
//"    Lmod Lcmp Rmod Rcmp nstr ", 
// Lmod=Att_lr[ind_lr]  Lcmp=Att_micomp[ind_lr] 
// Rmod=Att_lr[ind_lr]  Rcmp=Att_micomp[ind_lr] 
sprintf(Att_Mem[ P++],"%s\n",Att_String_List3[2]);                      
                N_String_in_Att_File++;                        
sprintf(Att_Mem[ P++],"%s\n",Att_String_List3[3]);                      
                N_String_in_Att_File++;                        
 
 
////////////////////// Write Att File ///////////////////////  
//                if (LAST_RECORD == TRUE) break; 
 }         
//////////////////  SECOND LOOP  //////////////////////////////////         
 
//////////////////  THEARD LOOP  ////////////////////////////////// 
          LAST_RECORD = FALSE; 
 
sprintf(Att_Mem[ P++],"%s\n",Att_String_List4[0]);                       
                N_String_in_Att_File++;                        
sprintf(Att_Mem[ P++],"%s\n",Att_String_List4[1]);                       
                N_String_in_Att_File++;                        
sprintf(Att_Mem[ P++],"%s\n",Att_String_List4[2]);                       
                N_String_in_Att_File++;                        
sprintf(Att_Mem[ P++],"%s\n",Att_String_List4[3]);                              
                N_String_in_Att_File++;                        
 
		  j = 0;                                   
		for (i = 0; i < n_eq_items; i++) {     
             
         
                 //m_lbox_equ.GetText(i,Search_Equ);      
                 sscanf(ModStaList[i],"%s%s", 
                        Model_Name,Station_Name); 
 // 3Smac
if (strcmp(Model_Name,_IND_3SMAC_) == 0)
sprintf(Model_Name,"%s@",Station_Name);
     
            for (q = 0; q < 2; q++){ 
            Att_wmaxw_i[q] = (float)0.;                         
            Att_wminw_i[q] = (float)0.;                         
            Att_lr[q]      = ' ';      
            Att_micomp[q]  = 0; 
            } 
            ind_lr = 0;      
         //////////////////////////// search_sei ///////////// 
         for (j = 0; j <  n_w_items; j++) { 
                 //m_box_w.GetText(j,Search_W);      
                 sscanf(RecDescrList[j],"%s%e%ld%e", 
                 Seis_Name,&mtmin,&mipoint,&mtmax);  
                     strcpy(Comp_Sei_Name,Seis_Name); 
                     *strchr(Comp_Sei_Name,':') = '\0';                         
              if    (strstr(Comp_Sei_Name,Station_Name) != NULL) break; 
         }                        
       
Start_Old_Station2 : ;                                                  
                  
                 strcpy(Loop_Seis_Name, Seis_Name); 
                 *strchr(Loop_Seis_Name,':') = '\0'; 
      if (mipoint >  0L) { 
            Att_wmaxw_i[ind_lr] = Pi2/mtmin + 3e-4; 
            Att_wminw_i[ind_lr] = Pi2/mtmax - 3e-4; 
       
                             }  else 
{ 
            Att_wmaxw_i[ind_lr] =(float)0.; 
            Att_wminw_i[ind_lr] =(float)0.; 
 
}                              
               strcpy(WStr,Seis_Name); 
        *(strchr(WStr,':')+1) = tolower(WStr[strlen(WStr)-1]);
        *(strchr(WStr,':')+2) = '\0';
                       
        for (k = 0; k < n_sei; k++){ 
         wf = sei[k];
        sprintf(  WSeis_name,"%s:%s",wf->sta,wf->comp);
      
        if ( (  ptr = strstr (WSeis_name,WStr) ) != NULL) break;        } 
        		                                                      
        if ( ptr == NULL) { 
        sprintf(ErrorReturnCode,"Error: Not found Sei Record  for  All of Stations!");
        return 4;         
        }		   
	   
		  az       = sei[k]->aztos;  
		  if ( az < (float) 0. ) az += (float)360.; 		  		   
		  if (sei[k]->comp[0] == 'z' ) {mlr = 'r'; micomp = 1L;} 
		   
		   
		   
		  if (sei[k]->comp[0] == 'r' ) { 
		  mlr = 'r';        
		  if ( az < (float) 45. || az > (float) 315. ||  
		  (az > (float)135. && az < (float)225.)  ) micomp = 2L; 
		     else micomp = 3L; 
		                                 } 
		   
		  if (sei[k]->comp[0] == 't' ) { 
		  mlr = 'l'; 
		  if ( az < (float) 45. || az > (float) 315. ||  
		  (az > (float)135. && az < (float)225.)  ) micomp = 3L; 
		     else micomp = 2L;		                                   
		                                  }		   
///////////////////////////////////////////////////////////////////////		   
		  Att_lr[ind_lr] = mlr; 
          Att_micomp[ind_lr] = (int) micomp;      
           
///////////////////////////////////////////////////////////////////////  
 
 
                                    
	if (	++j > n_w_items - 1 ) {LAST_RECORD = TRUE; goto Last_Record2; }    
	 
                 //m_box_w.GetText(j,Search_W); 
                 sscanf(RecDescrList[j],"%s%e%ld%e", 
                 Seis_Name,&mtmin,&mipoint,&mtmax);        
                     strcpy(Comp_Sei_Name,Seis_Name); 
                     *strchr(Comp_Sei_Name,':') = '\0';                          
                if ( strstr(Comp_Sei_Name,Loop_Seis_Name) != NULL ) 
                                {ind_lr++; goto Start_Old_Station2; }  
 Last_Record2 : ;  
////////////////////// Write Att File /////////////////////// 
                              
 
 
 
 
if (Att_lr[1] != ' '){ 
f1 = Att_wmaxw_i[0]; 
f2 = Att_wminw_i[0]; 
f3 = Att_wmaxw_i[1]; 
f4 = Att_wminw_i[1]; 
}                else    { 
          if (Att_lr[0] == 'l'){ 
          f1 = Att_wmaxw_i[0]; 
          f2 = Att_wminw_i[0]; 
          f3 = (float)0.0; 
          f4 = (float)0.0; 
             }  else  { 
          f1 = (float)0.0; 
          f2 = (float)0.0; 
          f3 = Att_wmaxw_i[0]; 
          f4 = Att_wminw_i[0]; 
             } 
}                   
 
           // Att_wmaxw_i[ind_lr] = Pi2/mtmin +  Att_dw/2; 
           // Att_wminw_i[ind_lr] = Pi2/mtmax -  Att_dw/2;                
//////////////////////////////// 
              sprintf(c_wmax,"%6.4f",f1);  
              sprintf(c_dw,"%6.4f",f2);    
              sprintf(c_wmax1,"%6.4f",f3);  
              sprintf(c_dw1,"%6.4f",f4);               
///////////////////////////////                        
 
sprintf(Att_Mem[ P++]," %s %s                         %s %s\n", 
c_wmax+1,c_dw+1,c_wmax1+1,c_dw1+1);                                                 
                N_String_in_Att_File++;                        
////////////////////// Write Att File ///////////////////////  
//                if (LAST_RECORD == TRUE) break;             
                   
 }                                
 
q = 0; 
while ( strstr(Att_String_List5[q],"#") == NULL) { 
 sprintf(Att_Mem[ P++],"%s\n",Att_String_List5[q]);q++; 
                N_String_in_Att_File++;                         
      }                       
  
//////////////////  THEARD LOOP  //////////////////////////////////         

//////////////////  FORTH LOOP  ////////////////////////////////// 
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 

                             // 
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
 
                                  int Count_Att,I_Att; 
               char Att_mlrfile[2][13];    
               char **Att_buffer,Att_max_s[17]; 
               int   Att_counter[2],Att_Buffer_Size,i_k; 
                
               float Att_max; 
                
 /*
                
                               if((att = fopen("Att_Name.Inp","w")) == NULL) {
  
                 sprintf(ErrorReturnCode,"Fatal Error: SpeCalcw: Cannot open file(r:21) 'Att_Name.Inp'");
                 return 21; 
                         }  
                          
  for (I_Att = 0; I_Att< N_Att_File - 1; I_Att++)                          
  fprintf(att,"%s",Att_Mem[I_Att]);                                                           
 
 
                             fclose(att);  
*/
 
          LAST_RECORD = FALSE; 
 
		  j = 0;                                   
		for (i = 0; i < n_eq_items; i++) {     
             
                             
                //m_lbox_equ.GetText(i,Search_Equ);      
                 sscanf(ModStaList[i],"%s%s", 
                        Model_Name,Station_Name);  
 // 3Smac
if (strcmp(Model_Name,_IND_3SMAC_) == 0)
sprintf(Model_Name,"%s@",Station_Name);
    
            for (q = 0; q < 2; q++){ 
            strcpy(Att_mlrfile[q]," "); 
            Att_wmaxw_i[q] = (float)0.;                         
            Att_wminw_i[q] = (float)0.;                         
            Att_lr[q]      = ' ';      
            Att_micomp[q]  = 0; 
            } 
            ind_lr = 0;       
         //////////////////////////// search_sei ///////////// 
 
         for (j = 0; j <  n_w_items; j++) { 
                 //m_box_w.GetText(j,Search_W);      
                 sscanf(RecDescrList[j],"%s%e%ld%e", 
                 Seis_Name,&mtmin,&mipoint,&mtmax);  
                     strcpy(Comp_Sei_Name,Seis_Name); 
                     *strchr(Comp_Sei_Name,':') = '\0';                          
              if    (strstr(Comp_Sei_Name,Station_Name) != NULL) break; 
         }                        
 
     
                  
Start_Old_Station4 : ;                                                  
                 strcpy(Loop_Seis_Name, Seis_Name); 
                        *strchr(Loop_Seis_Name,':') = '\0';                  
                 Att_counter[ind_lr ] = (int)mipoint; 

               strcpy(WStr,Seis_Name); 
        *(strchr(WStr,':')+1) = tolower(WStr[strlen(WStr)-1]);
        *(strchr(WStr,':')+2) = '\0';

        for (k = 0; k < n_sei; k++){ 
         wf = sei[k];
        sprintf(  WSeis_name,"%s:%s",wf->sta,wf->comp);
      
        if ( (  ptr = strstr (WSeis_name,WStr) ) != NULL) break; 
        } 
        		                                                      
        if ( ptr == NULL) { 
         sprintf(ErrorReturnCode,"Error: Not found Sei Record  for  All of Stations!");
        return 5;         
        }		   
		//fprintf(stderr,"**Point1   k = %d\n",k);
                  az       = sei[k]->aztos;  
		  if ( az < (float) 0. ) az += (float)360.; 		   
		  if (sei[k]->comp[0] == 'z' ) {mlr = 'r'; micomp = 1L;} 
		   
		   
		   
		  if (sei[k]->comp[0] == 'r' ) { 
		  mlr = 'r';        
		  if ( az < (float) 45. || az > (float) 315. ||  
		  (az > (float)135. && az < (float)225.)  ) micomp = 2L; 
		     else micomp = 3L; 
		                                 } 
		   
		  if (sei[k]->comp[0] == 't' ) { 
		  mlr = 'l'; 
		  if ( az < (float) 45. || az > (float) 315. ||  
		  (az > (float)135. && az < (float)225.)  ) micomp = 3L; 
		     else micomp = 2L;		                                   
		                                  }		   
///////////////////////////////////////////////////////////////////////		   
		  Att_lr[ind_lr] = mlr; 
          Att_micomp[ind_lr] = (int) micomp;      
          sprintf(Att_mlrfile[ind_lr],"%c%2.2dmod1",mlr,i+1);           
///////////////////////////////////////////////////////////////////////  
 
 
                                    
	if (	++j > n_w_items - 1 ) {LAST_RECORD = TRUE; goto Last_Record4; }    
	 
                 // m_box_w.GetText(j,Search_W); 
                 sscanf(RecDescrList[j],"%s%e%ld%e", 
                 Seis_Name,&mtmin,&mipoint,&mtmax);        
                     strcpy(Comp_Sei_Name,Seis_Name); 
                     *strchr(Comp_Sei_Name,':') = '\0';                          
                if ( strstr(Comp_Sei_Name,Loop_Seis_Name) != NULL ) 
                                {ind_lr++; goto Start_Old_Station4; }  
 Last_Record4 : ;  
////////////////////// Write Att File ///////////////////////  

               
                if((att = fopen(Att_Name_Inp,"w")) == NULL) {                   
                    sprintf(ErrorReturnCode,"Fatal Error: SpeCalcw: Cannot open file (r:22) %s",Att_Name_Inp);
                 return 22; 
                         }  
       
            
  Count_Att =  N_Att_File - 5*n_eq_items - 6;                 

  for (I_Att = 0; I_Att< Count_Att; I_Att++)                          
  fprintf(att,"%s",Att_Mem[I_Att]);                           
                         

  for (q = 0; q < n_eq_items; q++  )      {      
          
if ( q == i)                                    { 
         if (Att_lr[1] != ' '){ 
           i1 = 1; 
           i2 = (int)Att_micomp[0]; 
           i3 = 1; 
           i4 = (int)Att_micomp[1]; 
                                 }   
        else    { 
              if (Att_lr[0] == 'l'){ 
               i1 = 1; 
               i2 = (int)Att_micomp[0]; 
               i3 = 0; 
               i4 = 0; 
               }  else  { 
               i1 = 0; 
               i2 = 0; 
               i3 = 1; 
              i4 = Att_micomp[0];              
              
                        } 
              } 


fprintf(att,"%8.1f%8.4f %4d %4d %4d %4d %4d\n", 
 
       sei[k]->dist,sei[k]->aztos*Pi2/(float)360., 
       i1,  i2,  i3,  i4,  (int)1); 

 
}              else      { 

fprintf(att,"%8.1f%8.4f %4d %4d %4d %4d %4d\n", 
 
       sei[k]->dist,sei[k]->aztos*Pi2/(float)360., 
       0,0,0,0,1); 
 
} 


   I_Att++;    
                        
  fprintf(att,"%s",Att_Mem[I_Att++]);                                   
  fprintf(att,"%s",Att_Mem[I_Att++]);   
  fprintf(att,"%s",Att_Mem[I_Att++]);   
                                   
                    
   
   
        } 


for (q = I_Att; I_Att< N_Att_File - 1; I_Att++)                          
  fprintf(att,"%s",Att_Mem[I_Att]);      
////////////////////// Write Att File ///////////////////////  
   
 
        fclose(att);  
    
// 3Smac
if (strchr(Model_Name,'@') != 0)   
     fprintf(stderr,"Attenuation :> Model = 3Smac:> '%s'   Station = '%s' ( #%2d of %d )\n", 
     Model_Name ,Station_Name,i+1, n_eq_items);
else
     fprintf(stderr,"Attenuation :> Model = '%s'   Station = '%s' ( #%2d of %d )\n", 
     Model_Name ,Station_Name,i+1, n_eq_items);

///  !!!!!!                                                                  
                                                 qmain_(&ierr); 



///  !!!!!!                                                                  



 vNoticeDialog  note(this);
if ( ierr != 0) {
char wstr[1024],wstr1[256];
FILE *in;
strcpy(wstr,"Info : Attenuation Program: \nFatal Error:\n");
    strcat(wstr,"Model PREM\n ");
   if((in = fopen("list.err","r")) == NULL) { 
                sprintf(wstr1,"Info : Attenuation Program: \nFatal Error:\nCannot open file 'list.err'\n");
	(void)note.Notice(wstr1);
                sprintf(ErrorReturnCode,"Info : Attenuation Program: \nFatal Error:\nCannot open file 'list.err'\n");
                return 10; 
	}
  while (fgets(wstr1,256,in) != NULL) strcat(wstr,wstr1);
   fclose(in);
(void)note.Notice(wstr);
}
 
                                                                 
        
      for ( q = 0; q < 2; q++) { 
       if (Att_lr[q] != ' ') { 
          if (Att_counter[q] > 0)  { 
       Att_Buffer_Size =  80 * ( Att_counter[q] + 1); 
        
       Att_buffer = new char *[Att_counter[q] + 1];   
 for (i_k = 0; i_k <= Att_counter[q]; i_k++)          
       Att_buffer[i_k] = new char [80];          
 
                if((f = fopen(Att_mlrfile[q],"r")) == NULL) {  
                sprintf(ErrorReturnCode,"Fatal Error: Cannot open file \n'%s'",Att_mlrfile[q]);   
                                return 22; 
                         }                           
            
             if( fgets (Att_buffer[0],80,f) == NULL){ 
    sprintf(ErrorReturnCode,"Fatal Error: Unexpected end of file found\n %s at: 1 rec",Att_mlrfile[q]);    
   
                return 23;       
                                                        
     }                                                   
                                 Att_max = (float) 0.; 
        for (i_k = 1; i_k <= Att_counter[q]; i_k++) {  
       
             if( fgets (Att_buffer[i_k],80,f) == NULL){     
    sprintf(ErrorReturnCode,"Fatal Error: Unexpected end of file found\n %s at %d rec",Att_mlrfile[q],i_k + 1);    
   
                return 24;     
    }             
                       
           
      sscanf(Att_buffer[i_k],"%e%e%e%e%e",&f1,&f2,&f3,&f4,&f_m); 
       
 
     
    if ((float)fabs(f1) > Att_max ) Att_max = (float)fabs(f1);  
    if ((float)fabs(f2) > Att_max ) Att_max = (float)fabs(f2); 
                                                  } 
 
 
    Att_max /= (float) 10;                
  for (i_k = 0; i_k < 16; i_k++) Att_buffer[0][i_k] = ' ';   
  sprintf(Att_max_s,"%16.6e",Att_max); 
  for (i_k = 0; i_k < 16; i_k++) Att_buffer[0][i_k] =  Att_max_s[i_k]; 
 
 
 fclose(f); 
                if((f = fopen(Att_mlrfile[q],"w")) == NULL) { 
                sprintf(ErrorReturnCode,"Fatal Error: Cannot open file \n'%s'",Att_mlrfile[q]);   
                                return 26;             
             }                            
  
        for (i_k = 0; i_k <= Att_counter[q]; i_k++) { 
         
  fprintf(f,"%s",Att_buffer[i_k]);                                           
        }        
 fclose(f);         
                                 
 
 
 
  for (int k10 = 0; k10 <= Att_counter[q]; k10++) 
       delete [] Att_buffer[k10];          
       delete [] Att_buffer; 
 
         } //  End if (Att_counter[q] > 0)  
      } // End if (Att_lr[q] != ' ') 
       
}  // End Loop q       
 
          
                                                                     
//                if (LAST_RECORD == TRUE) break; 
 }   
   
//////////////////  FORTH LOOP  ////////////////////////////////// 
                                                         
 ///////////
    
///  !!!!!! 
 
///////////////// DELETE ???att1.*  ///////////// 

sprintf(text,"%crm ???att1",backslash);
system(text);

                 
        
///////////////// DELETE ???att1.*  ///////////// 
		 if ( Prepare_Memres(Att_Mem,N_Att_File,ErrorReturnCode) )  {    
           sprintf( ErrorReturnCode,"Error: Prepare_Memres Modul Stop!.See console.  ");
           return 11; 
                         } 

/*
    		 if ( Prepare_Gl2res(Att_Mem,N_Att_File,ErrorReturnCode) )  {    
           sprintf( ErrorReturnCode,"Error: Prepare_Memres Modul Stop!.See console.  ");
           return 12; 
                         } 
          
  */          
              
                           
               
              for (int k10 = 0; k10 < N_Att_File; k10++) 
                             delete   [] Att_Mem[k10];
			     delete   [] Att_Mem;                                                              
 
                           
                              
///////////////11111111111111111//////////////////////////////////////// 

// PHVEL:>  
if ( PhVelCheck == 1 || m_phvmax >  (float)0.0 ) 
do { 
 int i; 
 int j=0;          
 int  Ind_Zero; 
  FILE *inmod,*outmod,*inphv;   
  float qw1,qw2,qw3,qw4,qw5,ww_f; 
  float *ref,*jmf,*vel,*ww,*tt,v0,*x=0,*y=0; 
  int n;  int kl;  
  long ierr,nv; 
 char Mod_File_Name[_MAX_FILE_NAME];      
  char Phvel_File_Name[_MAX_FILE_NAME]; 
 char  s1[_MAX_FILE_NAME];  
          
strcpy(s2,m_WorkDir);     strcat(s2,"/PHVEL/");
 fprintf(out,"*******************************************\n");  
  fprintf(out,"phvcheck = %d phvmax = %8.3f\n",j,m_phvmax); 
 for(i = 0; i < Number_List_Mod_Phvel; i++) { 
Ind_Zero = 0; 

fprintf(out,"%s\n",List_Mod_Phvel[i]);     
 
 strcpy(Mod_File_Name,List_Mod_Phvel[i]); 
 Mod_File_Name[3] = '\0'; 
 strcat(Mod_File_Name,"mod1");         
  
 
 strcpy(s1,List_Mod_Phvel[i]+4); 
 strcat(s1,".");   
  kl =  strlen(s1); 
 s1[kl] = List_Mod_Phvel[i][0];  
 s1[kl+1] = '\0'; StrToLower(s1);
 strcpy(Phvel_File_Name,s2); 
 strcat(Phvel_File_Name,s1);    
 
           fprintf(out,"%s  rl = %s ph = %s\n",List_Mod_Phvel[i], 
           Mod_File_Name, Phvel_File_Name);    
            
                 if((inphv = fopen(Phvel_File_Name,"r")) == NULL) { 
//                fprintf(out,"Modul:> OnCalcSpe():>\n Cannot open file '%s'\n", 
//                Phvel_File_Name);   
                Ind_Zero = 1; 
                         }    
                          
                     
 
 
if (Ind_Zero == 0)  {    
     n = 0;                                              
 
      while ( fscanf (inphv,"%e%e\n", &qw1, &qw2) != EOF)  n++;   
                                fclose (inphv); 
       x = new float[n]; 
       y = new float[n]; 
                             
                 fopen(Phvel_File_Name,"r"); 
                 for (j = 0; j < n; j++) {                   
                 fscanf (inphv,"%e%e\n", &x[j], &y[j]); 
                 fprintf(out,"%e %e\n",x[j],y[j]);              
                 } 
                 fclose (inphv); 
 
                nv = (long)n; 
} 
                if((inmod = fopen(Mod_File_Name,"r")) == NULL) { 
                   
                sprintf(ErrorReturnCode,"Fatal Error: Cannot open file \n'%s'",Mod_File_Name);   
                                goto SSS;             
                          } 
      n = 1;                                               
      fscanf (inmod,"%e%e%e\n", &qw1, &qw2, &qw3); 
      while ( fscanf (inmod,"%e%e%e%e%e\n", &qw1, &qw2, &qw3,&qw4, &qw5 ) 
         != EOF)  n++;   
                                fclose (inmod); 
       ref = new float[n-1]; 
       jmf = new float[n-1]; 
       vel = new float[n-1]; 
       ww  = new float[n-1]; 
       tt  = new float[n-1];                                      
                if((inmod = fopen(Mod_File_Name,"r")) == NULL) { 
                sprintf(ErrorReturnCode,"Fatal Error: Cannot open file \n'%s'",Mod_File_Name);   
                                return 32;         
                         }                       
         fscanf (inmod,"%e%e%e\n", &qw1, &qw2, &qw3);                       
       for (j = 0; j < n-1; j++)                    
       fscanf (inmod,"%e%e%e%e%e\n", &ref[j], &jmf[j], &vel[j], &ww[j] ,&tt[j]); 
          fclose (inmod); 
        
	sprintf(text,"%crm %s",backslash,Mod_File_Name);
        system(text);
                    
 
                if((outmod = fopen(Mod_File_Name,"w")) == NULL) { 
               sprintf(ErrorReturnCode,"Fatal Error: Cannot open file \n'%s'",Mod_File_Name);   
                                return 33;                         
               }                       
            fprintf (outmod,"%13.6e  %13.6e  %13.6e\n", qw1, qw2, qw3); 
            for (j = 0; j < n-1; j++) {  
            if (Ind_Zero == 1)    { 
                       if ( Pi2 / ww[j] <= m_phvmax ) v0 = (float) 0.; 
                       else v0 = vel[j]; //(float) 0.; 
            } else     { 
                  if ( Pi2 / ww[j] <= m_phvmax ) v0 = (float) 0.;                 
                  else { 
                  ww_f = ww[j]; // / Pi2;       
//      FORTRAN INTPOL_1  SUBROUTINE ********************                   
                  intpol1_(x,y,&nv,&ww_f,&v0,&ierr); 
                  //fprintf(out,"n = %ld w = %e t = %e v0 = %e ierr = %ld \n",nv,ww_f,tt[j],v0,ierr);              
                       } 
           }        
            fprintf (outmod,"%13.6e %13.6e %13.6e %13.6e %13.6e %13.6e\n",  
            ref[j], jmf[j],  v0, vel[j],ww[j] ,tt[j]); 
            } 
 
         fclose (outmod); 
   
    
        delete [] ref; 
        delete [] jmf; 
        delete [] vel; 
        delete [] ww; 
        delete [] tt;  
 SSS: ;
if (Ind_Zero == 0) { 
       delete [] x; 
       delete [] y;                                            
  } 
   }                  
  

}while(0); 

////////////////////////////////////////////////////////////////////
        for ( int k10 = 0; k10 <  n_sei; k10++)  
        delete [] List_Mod_Phvel[k10];
        delete [] List_Mod_Phvel;
                             fclose(out);       
  chdir(m_WorkDir);
  return 0;                             
} 
void SpePrepCmdWindow::Write_structure(char *Model_File_Name,FILE *att)     
{ 

                    
                    int i,m;        
                    float f_m; 
                               
  char str1[24],str2[24];
                        _MLTM*      p_Mltm  = pMod;  
                        Model *Mod=0;                
        strcpy(str1,Model_File_Name);      StrToLower(str1);
// !a!
  //fprintf(stderr,"$$$ Model_File_Name = '%s' str1  = '%s'\n", Model_File_Name,str1   );      
// !a!
       for (  i = 0;i < p_Mltm->Get_I_N_MOD(); i++) {  
     
       Mod =    p_Mltm->Get_M(i); 
       strcpy(str2,Mod->Get_fname());      StrToLower(str2); 
       if (strcmp(str1,str2) == 0) break;    
       }
// !a!                      

//  fprintf(stderr,"### Model_File_Name = '%s'  Mod->Get_fname  = '%s'\n",str1,str2   );      
//  fprintf(stderr,"### mmax =%d  name1 = %s name2  = %s\n",i,str1,Mod->Get_fname()   );


// !a!

       fprintf(att,"mmax =%3d  ndiv =  2\n",Mod->Get_n_val()   );                  
       fprintf(att,"%s\n","        d         a         b        rho    ");                           
         for (m = 0; m < Mod->Get_n_val() - 1; m++) { 
         fprintf(att,"%10.4f%10.4f%10.4f%10.4f\n", 
         Mod->Get_d()[m],Mod->Get_a()[m],Mod->Get_b()[m],Mod->Get_rho()[m]); 
          
                                                    }        
         i = Mod->Get_n_val() - 1;                             
         fprintf(att,"          %10.4f%10.4f%10.4f\n", 
         Mod->Get_a()[i],Mod->Get_b()[i],Mod->Get_rho()[i]); 
 
     if (Mod->Get_b()[0] > (float)1.e-6 )  f_m = Mod->Get_b()[0] * (float)0.81;  
                     else  f_m = Mod->Get_a()[0];  
fprintf(att,"%s\n","fact=  4"); 
fprintf(att,"c1  =%6.2f  dc  =  0.01\n", f_m ); 

 }    
int SpePrepCmdWindow::Prepare_Memres(char ** Att_Mem , int N_Att_File,
char *ErrorReturnCode) 
{    
  //QQQ////////////////////////////////////////////////////////
            char Att_Name_Inp[_MAX_FILE_NAME];
         strcpy(Att_Name_Inp,Dir_mom_tens);   // m_ResultDir
         strcat(Att_Name_Inp,"/momres.inp");                        
 FILE *att; 
                if((att = fopen(Att_Name_Inp,"w")) == NULL) { 
   sprintf( ErrorReturnCode, "Fatal Error:(Prepare_Memres) Cannot open file  %s",
   Att_Name_Inp);
	    return 5; 
               
                         }                  
 
 
                         char *ptr;char  s1[256];  
                          
                          
 
		                            int m,i,j;
        	                               int n_eq_items = N_ModStaList; 
		                               int n_w_items  = N_RecDescrList; 
		                               char Model_Name[9],Station_Name[9], 
		                                    Seis_Name[24],Loop_Seis_Name[24]; 
		                                   
		                          char Model_File_Name[16];  
                                  int   Att_n,jk; 
                                  float Att_dw,Att_wmax,Att_wmaxw,Att_wminw; 
                                    
                                   
                                  int n_str[99];  
                                   
                                     
                                  int Exist_000,kstr; 
 
         Att_n     = 0;       
      for ( j = 0; j <  n_w_items; j++){    
                 sscanf(RecDescrList[j],"%s%e%ld%e", 
                 Seis_Name,&mtmin,&mipoint,&mtmax);          
                 if ( (int )mipoint > Att_n)  Att_n = (int )mipoint; 
                                                 }          
                    jk = Exist_000 = 0;                          
                    sscanf(ModStaList[0],"%s%s", 
                    Model_Name,Station_Name);         
 // 3Smac
if (strcmp(Model_Name,_IND_3SMAC_) == 0)
sprintf(Model_Name,"%s@",Station_Name);
     
                   strcpy(Loop_Seis_Name,Model_Name); 
       jk = 1;
      for ( j = 0; j <  n_eq_items; j++)         {
    
            sscanf(ModStaList[j],"%s%s", 
                    Model_Name,Station_Name);  
 // 3Smac
if (strcmp(Model_Name,_IND_3SMAC_) == 0)
sprintf(Model_Name,"%s@",Station_Name);
        
            if( strstr (Loop_Seis_Name,Model_Name) == NULL) jk++;          
            if( strstr (Model_Name,"000") != NULL   ) Exist_000 = 1;  
            strcpy(Loop_Seis_Name,Model_Name);             
                                                 } 
                                                   
            if ( Exist_000 == 0)  kstr = jk + 1; else kstr = jk; 
                                                  
         Att_dw    = (Pi2/m_tmin_com_e - Pi2/m_tmax_com_e)/( m_npoints - 1 ); // Att_n 
         Att_wmax  =  Pi2/m_tmin_com_e;  
         Att_wmaxw =  Pi2/m_tmin_com_e + 3e-4; 
         Att_wminw =  Pi2/m_tmax_com_e - 3e-4;                                   
int    P = 0;    
 
                fprintf(att,"%s\n","                 Input data for program MOMRES "); 
                 P++;                              
                fprintf(att,"%s",Att_Mem[ P++]); 
                fprintf(att,"%s",Att_Mem[ P++]); 
  
              char c_wmax[8],c_dw[8];        
               
              sprintf(c_wmax,"%7.5f",Att_wmax);  
              sprintf(c_dw,"%7.5f",Att_dw); 
       fprintf(att,"kstr=%2d  kmax=%3ld  wmax=%s  dw  =%s  maxLmodes= 1  maxRmodes= 1\n", 
       kstr,m_npoints,c_wmax+1,c_dw+1);            //Att_n 
                  P++;                    
                fprintf(att,"%s",Att_Mem[ P++]); 
                fprintf(att,"%s",Att_Mem[ P++]); 
              sprintf(c_wmax,"%6.4f",Att_wmaxw);  
              sprintf(c_dw,"%6.4f",Att_wminw); 
       fprintf(att," %s %s\n", c_wmax + 1,c_dw + 1); 
                  P++; 
                fprintf(att, "%s",Att_Mem[ P++]); 
                fprintf(att, "%s",Att_Mem[ P++]); 
              sprintf(c_wmax,"%6.4f",Att_wmaxw);  
              sprintf(c_dw,"%6.4f",Att_wminw); 
       fprintf(att," %s %s\n\n", c_wmax + 1,c_dw + 1);           
                   P++; 
                         i = 0;      
                  
       fprintf(att,"%6.2f %6.2f  %d  - depth of the source\n", 
       StartDepth,StepDepth,N_StepDepth);


              
            
           m = 0;  
// 3Smac

            sprintf(Model_File_Name,"%s.mod",nameSourceModel); 
           if (strncmp( _IND_3SMAC_,nameSourceModel,strlen( _IND_3SMAC_)) ==0 )
 strcpy(Model_File_Name,"000@.mod"); 
//!a!
 fprintf(stderr,"Source Model '%s' Model File Name '%s'\n", nameSourceModel,Model_File_Name); 
//!a!
            fprintf(att,"\n%s%s\n","Source region - ",Model_File_Name); 

            Write_structure(Model_File_Name,att); 

    
                               m++; 
           strcpy (Loop_Seis_Name,"000");                       
 
      for ( j = 0; j <  n_eq_items; j++)         {  
            sscanf(ModStaList[j],"%s%s", 
                    Model_Name,Station_Name);  
 // 3Smac
if (strcmp(Model_Name,_IND_3SMAC_) == 0)
sprintf(Model_Name,"%s@",Station_Name);  
  
                                                  // == 
            if( strstr (Loop_Seis_Name,Model_Name) == NULL){ 
            sprintf(Model_File_Name,"%s.mod",Model_Name);  
            fprintf(att,"\nStation %s\n",Model_Name); 
            Write_structure(Model_File_Name,att);m++;     
                                                           }    
                    n_str[j] = m; 
                    strcpy (Loop_Seis_Name,Model_Name);                       
     } 
                                                   
//////////////////////////////////////////////////////////////////// 
fprintf(att,"\n%s\n","      Recorder's location, number of modes, component's number"); 
fprintf(att,"%s\n","and number of corresponding structure, take-off angle and sign of P-wave"); 
fprintf(att,"%s\n","      (If nstr(i)=nstr(j)=...=nstr(k), then lines i,j,...,k should" ); 
fprintf(att,"%s\n","follow each other and if Lmod(j)+Rmod(j) < Lmode(k)+Rmode(k), then j > k)"); 
   
  int Count_Att =  N_Att_File - 5*n_eq_items - 6;                 
  //int length = m_list_sign.GetLength(); 
  //char * s   = m_list_sign.GetBuffer(length+1);  
  
   
  fprintf(att,"%s",Att_Mem[Count_Att - 2]);   
  fprintf(att,"%s\n","   dist      fi   Lmod Lcmp Rmod Rcmp nstr take-off P-sgn");   
  for ( i = Count_Att,m=0; i< Count_Att -1 + 4* n_eq_items ; i +=4,m++) { 
           
             
  sprintf(s1,"%s",Att_Mem[i]); ptr = strrchr(s1,'1'); *(ptr-1) = '\0';   
  fprintf(att,"%s%2d %8.4f   %4.1f\n",s1,n_str[m],0.0,0.0);  //ken_angl,p_sign);                          
  }   
  jk = i;                                                             
                    // m_list_sign.ReleaseBuffer(); 
fprintf(att,"\n%s\n","   wmax and wmin for all Love and Rayleigh modes for each recorder");   
  for ( i = jk + 1; i< jk + 1 + 2+ n_eq_items; i++) { 
  fprintf(att,"%s",Att_Mem[i]);                           
  }   


   
//fprintf(att,"\n%s\n","  15.  15.    6  - dip0, ddip, ndip");     
//fprintf(att,"\n%s\n","   0.  15.   12  - strik0, dstrik, nstrik");     
//fprintf(att,"\n%s\n","   0.  15.   12  - slip0, dslip, nslip"); 

fprintf(att,"\n%f %f %d %s\n",dip0,ddip,ndip, "  - dip0, ddip, ndip");     
fprintf(att,"\n%f %f %d %s\n",strik0,dstrik,nstrik,"  - strik0, dstrik, nstrik");     
fprintf(att,"\n%f %f %d %s\n",slip,dslip,nslip,"  - slip0, dslip, nslip"); 
fprintf(att,"\n%f %f %d %s\n",angl,dangl,nangl,"  - angl_dc0, dangl_dc, nangl_dc"); 
//fprintf(att,"\n%s\n","   0.   0.    1  ");         
      
                    fclose(att); 
return 0;
}  
 
 
int SpePrepCmdWindow::Prepare_Gl2res(char ** Att_Mem , int N_Att_File,
char * ErrorReturnCode) 
{ 

 //QQQ//////////////////////////////////////////////////////// 
                  
          char Att_Name_Inp[_MAX_FILE_NAME];
         strcpy(Att_Name_Inp,Dir_mom_tens); //   m_ResultDir
         strcat(Att_Name_Inp,"/gl2res.inp");                          
 FILE *att; 
                if((att = fopen(Att_Name_Inp,"w")) == NULL) { 
   sprintf( ErrorReturnCode, "Fatal Error:(Prepare_Gl2res) Cannot open file  %s",
   Att_Name_Inp);
	    return 5; 
               
                         }                  

///////////////////////////////////   OPEN FILE OUT //////////////// 

                                       int i,j,m; 
 
                                char *ptr; char  s1[256];
                          
 
        	                               int n_eq_items = N_ModStaList; 
		                               int n_w_items  = N_RecDescrList; 
		                               char Model_Name[9],Station_Name[9], 
		                                    Seis_Name[24],Loop_Seis_Name[24]; 
		                                   
		                          char Model_File_Name[16];  
		                            
                                  int   Att_n,jk; 
                                  float Att_dw,Att_wmax,Att_wmaxw,Att_wminw; 
                                    
                                  int n_str[99];  
                                   
                                     
                                  int Exist_000,kstr; 
 
         Att_n     = 0;       
      for ( j = 0; j <  n_w_items; j++){    
                   sscanf(RecDescrList[j],"%s%e%ld%e", 
                 Seis_Name,&mtmin,&mipoint,&mtmax);             
                 if ( (int )mipoint > Att_n)  Att_n = (int )mipoint; 
                                                 }          
                    jk = Exist_000 = 0;                          
                 sscanf(ModStaList[0],"%s%s", 
                    Model_Name,Station_Name);       
 // 3Smac
if (strcmp(Model_Name,_IND_3SMAC_) == 0)
sprintf(Model_Name,"%s@",Station_Name);
                                                          
             jk = 1;
            strcpy(Loop_Seis_Name,Model_Name); 
       
      for ( j = 0; j <  n_eq_items; j++)         {    
           sscanf(ModStaList[j],"%s%s", 
                    Model_Name,Station_Name);  
 // 3Smac
if (strcmp(Model_Name,_IND_3SMAC_) == 0)
sprintf(Model_Name,"%s@",Station_Name);
          
            if( strstr (Loop_Seis_Name,Model_Name) == NULL) jk++;          
            if( strstr (Model_Name,"000") != NULL   ) Exist_000 = 1;  
            strcpy(Loop_Seis_Name,Model_Name);             
                                                 } 
                                                   
            if ( Exist_000 == 0)  kstr = jk +1; else kstr = jk;
                                                  
         Att_dw    = (Pi2/m_tmin_com_e - Pi2/m_tmax_com_e)/(m_npoints - 1 );//  Att_n 
         Att_wmax  =  Pi2/m_tmin_com_e;  
         Att_wmaxw =  Pi2/m_tmin_com_e + 3e-4; 
         Att_wminw =  Pi2/m_tmax_com_e - 3e-4;                                   
int    P = 0;    
                fprintf(att,"%s\n","	                        Input data for program GL2RES"); 
                 P++;                              
                fprintf(att,"%s",Att_Mem[ P++]); 
                fprintf(att,"%s",Att_Mem[ P++]); 
  
              char c_wmax[8],c_dw[8];        
               
              sprintf(c_wmax,"%7.5f",Att_wmax);  
              sprintf(c_dw,"%7.5f",Att_dw); 
       fprintf(att,"kstr=%2d  kmax=%3ld  wmax=%s  dw  =%s  maxLmodes= 1  maxRmodes= 1\n", 
       kstr,m_npoints,c_wmax+1,c_dw+1); // Att_n 
                  P++;                    
                fprintf(att,"%s",Att_Mem[ P++]); 
                fprintf(att,"%s",Att_Mem[ P++]); 
              sprintf(c_wmax,"%6.4f",Att_wmaxw);  
              sprintf(c_dw,"%6.4f",Att_wminw); 
       fprintf(att," %s %s\n", c_wmax + 1,c_dw + 1); 
                  P++; 
                fprintf(att, "%s",Att_Mem[ P++]); 
                fprintf(att, "%s",Att_Mem[ P++]); 
              sprintf(c_wmax,"%6.4f",Att_wmaxw);  
              sprintf(c_dw,"%6.4f",Att_wminw); 
       fprintf(att," %s %s\n\n", c_wmax + 1,c_dw + 1);           
                   P++; 
                         i = 0;                      
       fprintf(att,"z0 =%6.2f - depth of the source\n", 
       pCDbeSeis->ps->sei[0]->depth); 
              
            
           m = 0;  
            fprintf(att,"\n%s\n","Source region - 000.MOD"); 
            strcpy(Model_File_Name,"model.000"); 
            Write_structure(Model_File_Name,att);     
                               m++; 
           strcpy (Loop_Seis_Name,"000");                       
 
      for ( j = 0; j <  n_eq_items; j++)         {    
             sscanf(ModStaList[j],"%s%s", 
                    Model_Name,Station_Name); 
 // 3Smac
if (strcmp(Model_Name,_IND_3SMAC_) == 0)
sprintf(Model_Name,"%s@",Station_Name);
                                                  // == 
            if( strstr (Loop_Seis_Name,Model_Name) == NULL){ 
            sprintf(Model_File_Name,"%s.mod",Model_Name);  
            fprintf(att,"\nStation %s\n",Model_Name); 
            Write_structure(Model_File_Name,att);m++;     
                                                           }    
                    n_str[j] = m; 
                    strcpy (Loop_Seis_Name,Model_Name);                       
     } 
                                                   
//////////////////////////////////////////////////////////////////// 
fprintf(att,"\n%s\n","      Recorder's location, number of modes, component's number"); 
fprintf(att,"%s\n","and number of corresponding structure, take-off angle and sign of P-wave"); 
fprintf(att,"%s\n","      (If nstr(i)=nstr(j)=...=nstr(k), then lines i,j,...,k should" ); 
fprintf(att,"%s\n","follow each other and if Lmod(j)+Rmod(j) < Lmode(k)+Rmode(k), then j > k)"); 
   
  int Count_Att =  N_Att_File - 5*n_eq_items - 6;                 
  //int length = m_list_sign.GetLength(); 
  //char * s   = m_list_sign.GetBuffer(length+1);  
  
     
  fprintf(att,"%s",Att_Mem[Count_Att - 2]);   
fprintf(att,"%s\n","   dist      fi   Lmod Lcmp Rmod Rcmp nstr take-off P-sgn");   
  for ( i = Count_Att,m=0; i< Count_Att -1 + 4* n_eq_items ; i +=4,m++) { 
                                        //4 
                  // Print take-off P-sgn                       
            //m_lbox_equ.GetText(m,Search_Equ);      
            //sscanf((const char *)Search_Equ,"%s%s", Model_Name,Station_Name);   
            //ptr = strstr(s,Station_Name); 
 
       //sscanf(ptr+4,"%f %f",&ken_angl,&p_sign);             
             
  sprintf(s1,"%s",Att_Mem[i]); ptr = strrchr(s1,'1'); *(ptr-1) = '\0';   
  fprintf(att,"%s%2d %8.4f   %4.1f\n",s1,n_str[m],0.0,0.0); //ken_angl,p_sign);                             
  }   
  jk = i;                                                             
                    // m_list_sign.ReleaseBuffer(); 
fprintf(att,"\n%s\n","   wmax and wmin for all Love and Rayleigh modes for each recorder");   
  for ( i = jk + 1; i< jk + 1 + 2+ n_eq_items; i++) { 
  fprintf(att,"%s",Att_Mem[i]);                           
  }   
      
fprintf(att,"\n%s\n","  0. 285.   20      -   lmax1,lmax2,nlmax");     
fprintf(att,"\n%s\n","  0. 135.   10      -   lmin1,lmin2,nlmin");     
fprintf(att,"\n%s\n","  0. 160.    9     -   fiaxis1,fiaxis2,nfiaxis");          
fprintf(att,"\n%s\n","  0. 340.   18     -   fivel1,fivel2,nfivel"); 
fprintf(att,"\n%s\n","  0.  3.6   10       -   vel1,vel2,nvel"); 
fprintf(att,"\n%s\n"," 10. 100.   10      -   time1,time2,ntime"); 
fprintf(att,"%s\n",".965926 -.224144 -.129409  .258819  .836517  .482962  un(i),du(i)");       
fprintf(att,"%s\n","0.43e28  0     -  m0, im0 - if im0=1 then m0 will be recalculated");      
                    fclose(att); 
return 0;

}  
int  
SpePrepCmdWindow::Read_Seismogram(int *kk,int n_l,char *Seis_Name,char * ErrorReturnCode) { 
 static int Ind = 0;
 Ind++;
//fprintf(stderr," ####    Read Seism %d %s\n",Ind, Seis_Name);
           int k,i,n,e;   
SET_SEI *ps = pCDbeSeis->ps;
  
   
   SEI **WFSEI = ps->sei;
   SEI *wfi = 0,*wfe,*wfn;
   char LSeis_name[24],s1[24],s2[24];
   char WSeis_name[24];
   char *ptr=0;
   strcpy(s1," ");strcpy(s2," ");
    char Date_In[50];
    char wstr[50];
double wflddate;
int year;
int month;
int day;
int doy;
int hour;
int minute;
float second;

//////////////////////////////////////////////////////////////////////
	strcpy (LSeis_name,Seis_Name); StrToLower(LSeis_name);
	if ( LSeis_name[strlen(LSeis_name) - 1] == 'z' )
	strcpy(s1,LSeis_name);
	else {
	strcpy(s1,LSeis_name); s1[strlen(s1)-1] = 'n'; 
	strcpy(s2,LSeis_name); s2[strlen(s2)-1] = 'e';
	}
 
    for  ( i = 0;i < ps->n; i++ ) {
    wfi = WFSEI[i];
 
        sprintf(  WSeis_name,"%s:%s",wfi ->sta,wfi->chan);StrToLower(WSeis_name);
        if ( (  ptr = strstr (WSeis_name,s1) ) != NULL) {


                   strcpy(Date_In,strchr(RecordInList[n_l],' '));
                   while (Date_In[0] == ' ') strcpy(Date_In,Date_In +1);
        	  fmtetoh(wfi->lddate,&year,&month,&day,&doy,&hour,&minute,&second);     
	sprintf(  wstr,"  %2d/%2d/%4d %2d:%2d:%2d",
	 month,day,year,hour,minute,(int)(second+0.5) );
                    while (wstr[0] == ' ') strcpy(wstr,wstr+1);
            if ( strstr(Date_In,wstr) != NULL)          
                   break;
                        } 

        } 
        		                                                      
        if ( ptr == NULL) {
        sprintf(ErrorReturnCode,"Error: Not found Sei Record  for %s !",Seis_Name); 
        return 2;         
        } 
//fprintf(stderr,"### %d  %s  %s\n",i, WSeis_name,wstr );
    char *st =getenv("FMT_ARCHITECTURE_");
    int linuxPlatphorm = 0;
    if(st == NULL)		{
	sprintf( ErrorReturnCode,"Fatal Error:> It is not define env variable 'FMT_ARCHITECTURE_'");			
	return 16;
	}
    else	{
	if (strstr(st,"linuxelf") !=0)	linuxPlatphorm = 1;
	else linuxPlatphorm = 0;
	 
    }
    
 k = i;
 FILE	*in;
 char work[_MAX_FILE_NAME];
            wfi->s = new float [wfi->nsampl];  

           strcpy(work,wfi->dir);
           strcat(work,"/");
           strcat(work,wfi->dfile); 

           if ((in = fopen(work, "r")) == NULL)
	   {
  sprintf( ErrorReturnCode, "Fatal Error: Cannot open file  %s",
   work);
	    return 5;
	  }
            fread(wfi->s,sizeof(float),wfi->nsampl,in);
            if (linuxPlatphorm  == 1) {
	    TransformFloatArray(wfi->s,wfi->nsampl);
	    //fprintf(stderr,"s:>  %g %g\n",wfi->s[0],wfi->s[1]);
	    }
	    //else fprintf(stderr,"UNIX UNIX UNIX UNIX UNIX \n");
	    
 

	  fclose ( in ) ; 
   
                  *kk = k;
		  mnsample = wfi->nsampl; 
		  mt0      = wfi->t0; 




	if ( LSeis_name[strlen(LSeis_name) - 1] == 'z' ) 
            { wfi->comp[0] = 'z'; long mi;
// correction direction up/down for Z comp vang

  float psi = (float)((float)4.*(float)atan(1.)/(float)180.)*wfi->vang;

  for(mi = 0; mi < wfi->nsampl; mi++) wfi->s[mi] *= cos(psi);
return 0;} 
       n = i;
wflddate = WFSEI[n]->lddate;
int boola = 0;
double min_lddate = wflddate;
 for  ( i = 0;i < ps->n; i++ ) {
    wfi = WFSEI[i];
 
        sprintf(  WSeis_name,"%s:%s",wfi ->sta,wfi->chan);StrToLower(WSeis_name);

        if ( (  ptr = strstr (WSeis_name,s2) ) != NULL)  { 
           if ( fabs(wfi->lddate - wflddate ) <=  min_lddate) { 
          min_lddate = fabs(wfi->lddate - wflddate );k = i;boola=1;
           
 								}
		
             } 
        

  }	


  if ( boola == 0) {
        sprintf(ErrorReturnCode,"Error: Not found Sei Record  for %s !",Seis_Name); 
        return 2; 
}

   e = k;
fmtetoh(WFSEI[n]->lddate,&year,&month,&day,&doy,&hour,&minute,&second);     
	sprintf(  wstr,"  %2d/%2d/%4d %2d:%2d:%2f",
	 month,day,year,hour,minute,second );
                    while (wstr[0] == ' ') strcpy(wstr,wstr+1);

//fprintf(stderr," n = %d %s:%s  %s\n", n,WFSEI[n]->sta,WFSEI[n]->chan,wstr );


fmtetoh(WFSEI[e]->lddate,&year,&month,&day,&doy,&hour,&minute,&second);     
	sprintf(  wstr,"  %2d/%2d/%4d %2d:%2d:%2f",
	 month,day,year,hour,minute,second );
                    while (wstr[0] == ' ') strcpy(wstr,wstr+1);

//fprintf(stderr,"### e = %d %s:%s  %s\n", e,WFSEI[e]->sta,WFSEI[e]->chan,wstr );
  wfi = WFSEI[e];
            wfi->s = new float [wfi->nsampl];  

           strcpy(work,wfi->dir);
           strcat(work,"/");
           strcat(work,wfi->dfile); 

           if ((in = fopen(work, "r")) == NULL)
	   {
  sprintf( ErrorReturnCode, "Fatal Error: Cannot open file  %s",
   work);
	    return 5;
	  }
            fread(wfi->s,sizeof(float),wfi->nsampl,in);
            if (linuxPlatphorm  == 1) TransformFloatArray(wfi->s,wfi->nsampl);
   fclose ( in ) ;

   
   
 
 long m,m1,q,q1;
wfe = WFSEI[e];
wfn = WFSEI[n];
long RTNSampl;
if (wfe->nsampl > wfn->nsampl)RTNSampl =   wfe->nsampl;
     else RTNSampl = wfn->nsampl; 
float *rSei = new float [RTNSampl];
float *tSei = new float [RTNSampl]; 
float *nSei = wfn->s;
float *eSei = wfe->s;
float Rad = (float)((float)4.*(float)atan(1.)/(float)180.); 
/*
                float Sinfi = (float)sin(fi); 
                float Cosfi = (float)cos(fi); 
*/
                float dt0; 
                long st_dt0; 
                float flt;     

                float ampe = wfe->amp;
                AMPe =      wfe->amp;
                float ampn =  wfn->amp;  
                AMPn =  wfn->amp;
float cosHangN  = (float)cos(wfn->hang  * Rad) * ampn;
float sinHangN  = (float)sin(wfn->hang  * Rad) * ampn;
float cosHangE  = (float)cos(wfe->hang  * Rad) * ampe;
float sinHangE  = (float)sin(wfe->hang  * Rad) * ampe;

float cosAzfrst = (float)cos(wfe->azfrs * Rad);
float sinAzfrst = (float)sin(wfe->azfrs * Rad);
float xnn, xee;
                // N == T E == R 
           if (wfe->t0 > wfn->t0 ) { 
                   dt0 = wfe->t0 - wfn->t0; 
                   st_dt0 =  (long)(dt0/wfe->dt + (float)0.5); 
                for (m = 0; m < st_dt0 ;m++) { 
                    tSei[m] =   (float)0.0; 
                 // rSei[m] =   (float)0.0;   
                    } 
                  for (m = st_dt0,q=0; m < wfn->nsampl ;m++,q++) { 
                    if (q >= wfe->nsampl) break;
 xnn = nSei[m] * cosHangN + eSei[q] * cosHangE;
 xee = nSei[m] * sinHangN + eSei[q] * sinHangE;
                    tSei[m] =   xnn * sinAzfrst - xee * cosAzfrst; 
                    rSei[q] = - xnn * cosAzfrst - xee * sinAzfrst;   
                    } 	                        
                 for (q1 = q; q1 < wfe->nsampl ;q1++)     
                    rSei[q1] =   (float)0.0;                  
                 for (m1 = m; m1 < wfn->nsampl ;m1++)     
                    tSei[m1] =   (float)0.0; 
          }  else { 
                   dt0 = wfn->t0 - wfe->t0; 
                   st_dt0 =  (long)(dt0/wfn->dt + (float)0.5); 
                for (m = 0; m < st_dt0 ;m++) { 
                //  tSei[m] =   (float)0.0; 
                  rSei[m] =   (float)0.0;   
                    } 
                  for (m = st_dt0,q=0; m < wfe->nsampl ;m++,q++) { 
                    if (q >= wfn->nsampl) break; 
 xnn = nSei[m] * cosHangN + eSei[q] * cosHangE;
 xee = nSei[m] * sinHangN + eSei[q] * sinHangE;
                    tSei[m] =   xnn * sinAzfrst - xee * cosAzfrst; 
                    rSei[q] = - xnn * cosAzfrst - xee * sinAzfrst;   
                    } 	                        
                  
                 for (m1 = m; m1 < wfe->nsampl;m1++)     
                    rSei[m1] =   (float)0.0;                  
                 for (q1 = q; q1 < wfn->nsampl;q1++)     
                    tSei[q1] =   (float)0.0;                  
            }        
              
             flt = (float)fabs(tSei[0]); 
             for (m = 0; m < wfn->nsampl ;m++)  
             if ((float)fabs(tSei[m]) > flt) flt = (float)fabs(tSei[m]); 
             for (m = 0; m < wfn->nsampl ;m++)  
                         tSei[m] /= flt; 
              wfn->amp = flt;
             flt = (float)fabs(rSei[0]); 
             for (m = 0; m < wfe->nsampl ;m++)  
             if ((float)fabs(rSei[m]) > flt) flt = (float)fabs(rSei[m]); 
             for (m = 0; m < wfe->nsampl ;m++)  
                         rSei[m] /= flt; 
                 wfe->amp = flt;
      //  fprintf(stderr,"## wfe->amp  = %e wfn->amp  = %e \n",wfe->amp ,wfn->amp  );         
                 
                //N == T E == R       
float    az =  wfe->azfrs - (float)180.0;
         wfe->polan =  (float)90.0; 
         wfe->az    =  ((az) < 0) ? (az + (float)360.0 ) : (az);        
         wfe->comp[0] = 'r';
  
         az =  wfn->azfrs -  (float)90.0;  
         wfn->polan =  (float)90.0; 
         wfn->az    =  ((az) < 0) ? (az + (float)360.0 ) : (az);        
         wfn->comp[0] = 't';  



if ( LSeis_name[strlen(LSeis_name) - 1] == 't' ) { 


                  *kk = n;
		  mnsample = wfn->nsampl; 
		  mt0      = wfn->t0; 
   for (m = 0; m < wfn->nsampl ;m++) nSei[m] = tSei[m];



delete [] wfe->s; wfe->s = 0;
wfe->amp = AMPe;  
}
if ( LSeis_name[strlen(LSeis_name) - 1] == 'r' ) {
 
                  *kk = e;
		  mnsample = wfe->nsampl; 
		  mt0      = wfe->t0; 
for (m = 0; m < wfe->nsampl ;m++) eSei[m] = rSei[m];
delete [] wfn->s; wfn->s = 0;
 
wfn->amp = AMPn;
}
  delete  [] tSei;
  delete  [] rSei; 
return 0;
}






