//
// C++ Interface: records
//
// Description: 
//
//
// Author: fmt <fmt@localhost.localdomain>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef RECORDS_IMPLEMENTATION_H
#define RECORDS_IMPLEMENTATION_H
#include "ui_recordlst.h"
#include "projectwizard.h"
class LineDocProperty;
class PropertyValue;
class MDocument;
bool hasInputFiles(QString directory,QStringList &list);
class RecordsImpl : public QDialog, private Ui::RecordListBase {
    Q_OBJECT

public:
    RecordsImpl(QWidget *parent,MDocument* doc,ProWizard::DocumentUsing documentUsing);
    void FinishWizard();
    void GetDocumentFromDialog();
    bool CheckDialogParameeters();
    QListWidget * GetListWidgetProject (){return listWidgetProject;}
private slots:
void addsel();
void addall();
void delsel();
void delall();
void setOrbit();
void setOrbitAll();
void browse();
private:
    MDocument* doc;
    ProWizard::DocumentUsing documentUsing;
    void InitDialog();
    void SetDocumentToDialog();
    void SetFilesToInList();
    int FindDoubleRecordsInlistWidgetProject();
    bool CheckIsOrbit();
    bool GetFtanRange(QString &fileName);
    QList<PropertyValue* > values;
    QList<LineDocProperty* > propDocLine;
    QStringList recordList;
    QString inputDataDirectoryName;
    QString ftanPeriodFileName;
    QStringList RangeWaveListTmp;
    float rangeTmin;
    float rangeTmax;
    bool isFtanProject;
};

#endif
